/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { AnnotationLayer } from "./AnnotationLayer";
import { DependencyProperty } from "igniteui-angular-core";
import { Series } from "./Series";
import { FinalValueSelectionMode_$type } from "./FinalValueSelectionMode";
import { Brush } from "igniteui-angular-core";
import { Thickness } from "igniteui-angular-core";
import { FinalValueLayerFrame } from "./FinalValueLayerFrame";
import { List$1 } from "igniteui-angular-core";
import { Axis } from "./Axis";
import { Dictionary$2 } from "igniteui-angular-core";
import { Pool$1 } from "igniteui-angular-core";
import { AxisAnnotation } from "./AxisAnnotation";
import { Base, enumGetBox, fromEnum, Point_$type, markType, markDep } from "igniteui-angular-core";
import { AxisAnnotationFrameManager } from "./AxisAnnotationFrameManager";
import { PropertyMetadata } from "igniteui-angular-core";
import { DeviceUtils } from "igniteui-angular-core";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { BrushUtil } from "igniteui-angular-core";
/**
 * @hidden
 */
export let FinalValueLayer = /*@__PURE__*/ (() => {
    class FinalValueLayer extends AnnotationLayer {
        constructor() {
            super();
            this.axisAnnotationFormatLabel = null;
            this.w6 = null;
            this.w5 = null;
            let a = new FinalValueLayerFrame();
            let b = new FinalValueLayerFrame();
            let c = new FinalValueLayerFrame();
            let d = this.ji / 1000;
            this.uf = a;
            this.ue = b;
            this.ug = c;
            this.ab = FinalValueLayer.$;
        }
        get_d4() {
            return true;
        }
        cg() {
            return new FinalValueLayerView(this);
        }
        o0(a) {
            super.o0(a);
            this.w1 = a;
        }
        get yb() {
            return new Thickness(1, this.w9, this.xb, this.xa, this.w8);
        }
        w4() {
            return this.axisAnnotationFormatLabel != null;
        }
        vs(a, b) {
            if (this.w3 == null || this.w3 == a) {
                if (!this.at.c) {
                    this.pp(b);
                }
            }
        }
        vu(a, b) {
            super.vu(a, b);
            let c = a;
            c.f.clear();
            c.r.clear();
            c.q.clear();
            c.ac.clear();
            c.p.clear();
            c.ab.clear();
            c.h.clear();
            c.g.clear();
            c.i.clear();
            c.k.clear();
            c.m.clear();
            c.l.clear();
            c.j.clear();
            c.n.clear();
            c.o.clear();
            c.t.clear();
            c.s.clear();
            c.u.clear();
            c.w.clear();
            c.y.clear();
            c.x.clear();
            c.v.clear();
            c.z.clear();
            c.aa.clear();
            if (this.ul(this.w3)) {
                this.xs(this.w3, c);
            }
            else {
                for (let d of fromEnum(this.cy.series)) {
                    if (this.ul(d)) {
                        this.xs(d, c);
                    }
                    if (d.isStacked) {
                        d.n5((e) => {
                            if (this.ul(e)) {
                                this.xs(e, c);
                            }
                            if (e.dv) {
                                e.n3((f) => {
                                    if (this.ul(f)) {
                                        this.xs(f, c);
                                    }
                                    return true;
                                });
                            }
                            return true;
                        });
                    }
                    if (d.dv) {
                        d.n3((e) => {
                            if (this.ul(e)) {
                                this.xs(e, c);
                            }
                            return true;
                        });
                    }
                }
            }
        }
        ul(a) {
            if (!super.ul(a)) {
                return false;
            }
            if (this.xp != null) {
                if (a.ep) {
                    let b = a.lu();
                    if (!Base.equalsStatic(this.xp, b)) {
                        return false;
                    }
                }
                else {
                    if (!Base.equalsStatic(this.xp, a.name)) {
                        return false;
                    }
                }
            }
            return true;
        }
        oo() {
            super.oo();
            if (!this.at.c && !this.dj()) {
                return;
            }
            if (this.dj()) {
                this.xt(this.ug, false);
            }
            else {
                this.xt(this.ue, false);
            }
        }
        ya(a) {
            let b = NaN;
            let c = NaN;
            let d = this.w2;
            if (d == 0) {
                d = 1;
            }
            let e = false;
            if (d == 2) {
                e = true;
            }
            if (a.isVertical) {
                let f = a.as();
                if (f != null) {
                    if (d == 1 || d == 2) {
                        let g = this.to(this.cj);
                        if (f.ch) {
                            c = a.tm({ $type: Point_$type, x: g.right, y: g.bottom }).y;
                        }
                        else {
                            c = a.tm({ $type: Point_$type, x: g.right, y: g.top }).y;
                        }
                    }
                    else {
                        if (f.ch) {
                            c = 1;
                        }
                        else {
                            c = 0;
                        }
                    }
                }
                return a.th({ $type: Point_$type, x: 0, y: c }, e, true);
            }
            else {
                let h = a.as();
                if (h != null) {
                    if (d == 1 || d == 2) {
                        let i = this.to(this.cj);
                        if (h.ch) {
                            b = a.tm({ $type: Point_$type, x: i.left, y: i.top }).x;
                        }
                        else {
                            b = a.tm({ $type: Point_$type, x: i.right, y: i.top }).x;
                        }
                    }
                    else {
                        if (h.ch) {
                            b = 0;
                        }
                        else {
                            b = 1;
                        }
                    }
                }
                if (a.ek) {
                    return a.th({ $type: Point_$type, x: b, y: 0 }, e, true);
                }
                else {
                    return a.th({ $type: Point_$type, x: b, y: 0 }, e, true);
                }
            }
        }
        xs(a, b) {
            let c = this.ya(a);
            let d = this.tm(c);
            let e = this.ss;
            if (e == null) {
                e = this.sw;
            }
            if (e == null) {
                e = a.ss;
                if (e != null) {
                    e = this.w1.b8(e);
                }
            }
            AxisAnnotationFrameManager.c(b, c, a, this.cy, this.getEffectiveViewport(), e, this.x7, this.w7, this.x9, this.x8, this.yb, this.xc, this.x7, this.w7, this.x9, this.x8, this.yb, this.xc, a.isVertical, !a.isVertical);
        }
        xt(a, b) {
            let c = false;
            if (this.w5 == null) {
                c = true;
                this.w6 = new List$1(Axis.$, 0);
                this.w5 = new Dictionary$2(Axis.$, Pool$1.$.specialize(AxisAnnotation.$), 0);
            }
            AxisAnnotationFrameManager.d(this, a, c, this.w5, this.w6, b, this.xd, this.xd, this.axisAnnotationFormatLabel, this.axisAnnotationFormatLabel);
        }
        vx(a, b) {
            super.vx(a, b);
            if (this.dj()) {
                this.xt(this.ug, true);
            }
            else {
                this.xt(this.ue, false);
            }
        }
        fm() {
            return true;
        }
        o8(a, b, c, d) {
            super.o8(a, b, c, d);
            switch (b) {
                case FinalValueLayer.$$p[11]:
                case FinalValueLayer.$$p[12]:
                    this.pp(true);
                    break;
                case FinalValueLayer.$$p[1]:
                case FinalValueLayer.$$p[0]:
                case FinalValueLayer.$$p[3]:
                case FinalValueLayer.$$p[5]:
                case FinalValueLayer.$$p[7]:
                case FinalValueLayer.$$p[6]:
                case FinalValueLayer.$$p[4]:
                case FinalValueLayer.$$p[8]:
                case FinalValueLayer.$$p[9]:
                case FinalValueLayer.$$p[10]:
                    this.pp(true);
                    break;
                case "SeriesViewer":
                    let e = this.w6;
                    let f = this.w5;
                    if (f != null) {
                        for (let g of fromEnum(f)) {
                            let h = g.value;
                            h.c((i) => g.key.an.remove(i));
                            h.clear();
                        }
                        e.clear();
                        f.clear();
                    }
                    break;
            }
        }
    }
    FinalValueLayer.$t = markType(FinalValueLayer, 'FinalValueLayer', AnnotationLayer.$);
    FinalValueLayer.$$p = markDep(DependencyProperty, PropertyMetadata, FinalValueLayer, 'raisePropertyChanged', ['AxisAnnotationBackgroundCornerRadius:w7:xu', [1, DeviceUtils.g(3)], 'AxisAnnotationBackground:x7:xv', [Brush.$, null], 'AxisAnnotationInterpolatedValuePrecision:xd:xw', [1, -1], 'AxisAnnotationOutline:x8:xx', [Brush.$, null], 'AxisAnnotationPaddingBottom:w8:xy', [1, NaN], 'AxisAnnotationPaddingLeft:w9:xz', [1, NaN], 'AxisAnnotationPaddingRight:xa:x0', [1, NaN], 'AxisAnnotationPaddingTop:xb:x1', [1, NaN], 'AxisAnnotationStrokeThickness:xc:x2', [1, NaN], 'AxisAnnotationTextColor:x9:x3', [Brush.$, null], 'FinalValueSelectionMode:w2:x4', [FinalValueSelectionMode_$type, enumGetBox(FinalValueSelectionMode_$type, 0)], 'TargetSeriesName:xp:x5', [2, null], 'TargetSeries:w3:x6', [Series.$, null]]);
    return FinalValueLayer;
})();
/**
 * @hidden
 */
export let FinalValueLayerView = /*@__PURE__*/ (() => {
    class FinalValueLayerView extends AnnotationLayerView {
        constructor(a) {
            super(a);
            this.b7 = null;
            this.b7 = a;
        }
        au() {
            super.au();
        }
        b8(a) {
            if (a == null) {
                return a;
            }
            return BrushUtil.m(a, 0.1);
        }
        an(a) {
            super.an(a);
        }
    }
    FinalValueLayerView.$t = markType(FinalValueLayerView, 'FinalValueLayerView', AnnotationLayerView.$);
    return FinalValueLayerView;
})();
