/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { PriceVolumeTrendIndicatorStrategy } from "./PriceVolumeTrendIndicatorStrategy";
import { markType } from "igniteui-angular-core";
/**
 * @hidden
 */
export let PriceVolumeTrendIndicator = /*@__PURE__*/ (() => {
    class PriceVolumeTrendIndicator extends StrategyBasedIndicator {
        get_yy() {
            return new PriceVolumeTrendIndicatorStrategy();
        }
        get yy() {
            return this.get_yy();
        }
        get_zb() {
            return PriceVolumeTrendIndicator.$;
        }
        get zb() {
            return this.get_zb();
        }
    }
    PriceVolumeTrendIndicator.$t = markType(PriceVolumeTrendIndicator, 'PriceVolumeTrendIndicator', StrategyBasedIndicator.$);
    return PriceVolumeTrendIndicator;
})();
