import { IgCollection } from "igniteui-angular-core";
import { markType } from "igniteui-angular-core";
import { SyncableObservableCollection$2 } from "igniteui-angular-core";
import { SeriesLayerPropertyOverlay as SeriesLayerPropertyOverlay_internal } from './SeriesLayerPropertyOverlay';
import { IgxSeriesLayerPropertyOverlay as IgxSeriesLayerPropertyOverlay } from './igx-series-layer-property-overlay';
export class IgxSeriesLayerPropertyOverlayCollection extends IgCollection {
    constructor(list) {
        super();
        if (!IgxSeriesLayerPropertyOverlay.$type) {
            IgxSeriesLayerPropertyOverlay.$type = markType(IgxSeriesLayerPropertyOverlay, "IgxSeriesLayerPropertyOverlay");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!IgxSeriesLayerPropertyOverlay.$type) {
            IgxSeriesLayerPropertyOverlay.$type = markType(IgxSeriesLayerPropertyOverlay, "IgxSeriesLayerPropertyOverlay");
        }
        let coll = new SyncableObservableCollection$2(IgxSeriesLayerPropertyOverlay.$type, SeriesLayerPropertyOverlay_internal.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = new IgxSeriesLayerPropertyOverlay();
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    }
}
