/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { FinancialSeries } from "./FinancialSeries";
import { DependencyProperty } from "igniteui-angular-core";
import { ISortingAxis_$type } from "./ISortingAxis";
import { typeCast, markType, markDep } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { AxisRange } from "./AxisRange";
import { PropertyMetadata } from "igniteui-angular-core";
import { isNaN_ } from "igniteui-angular-core";
/**
 * @hidden
 */
var FinancialOverlay = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialOverlay, _super);
    function FinancialOverlay() {
        var _this = _super.call(this) || this;
        _this.x3 = false;
        _this.x3 = false;
        return _this;
    }
    FinancialOverlay.prototype.get_em = function () {
        return true;
    };
    FinancialOverlay.prototype.no = function (a, b, c, d) {
        _super.prototype.no.call(this, a, b, c, d);
        if (this.t9 != null && typeCast(ISortingAxis_$type, this.t9) !== null) {
            this.t9.i$i();
        }
        this.uq.b0.e(this.hj);
        this.x4();
        if (this.uv != null) {
            this.uv.c1();
        }
        this.pp(true);
    };
    FinancialOverlay.prototype.get_gk = function () {
        return true;
    };
    FinancialOverlay.prototype.o8 = function (a, b, c, d) {
        switch (b) {
            case "FastItemsSource":
                this.x3 = false;
                break;
            case FinancialOverlay.$$p[0]:
                this.x3 = false;
                this.pp(false);
                this.ol();
                break;
            case "XAxis":
                this.x3 = false;
                break;
        }
        _super.prototype.o8.call(this, a, b, c, d);
    };
    FinancialOverlay.prototype.bx = function () {
        if (this.by == 0) {
            return 1;
        }
        else {
            return _super.prototype.bx.call(this);
        }
    };
    FinancialOverlay.prototype.f4 = function (a, b) {
        if (this.f3(a, b)) {
            return true;
        }
        return false;
    };
    FinancialOverlay.prototype.ac = function () {
        _super.prototype.ac.call(this);
        this.pp(false);
    };
    FinancialOverlay.prototype.fo = function (a) {
        var b = this.c6 != null ? this.c6.indexOf(a) : -1;
        var c = this.cj.by;
        c = c.copy();
        var d = this.cj.bx;
        var e = new Rect(0, 0, 0, 1, 1);
        var f = this.tq(this.cj);
        var g = new ScalerParams(0, e, e, this.t9.ch, f);
        var h = new ScalerParams(0, e, e, this.uv.ch, f);
        h.b = this.h2();
        if (b >= 0 && Rect.l_op_Inequality(c, null) && Rect.l_op_Inequality(d, null)) {
            if (this.t9 != null) {
                var i = this.t9.ej(b, g);
                if (i < c.left + 0.1 * c.width) {
                    i = i + 0.4 * c.width;
                }
                if (i > c.right - 0.1 * c.width) {
                    i = i - 0.4 * c.width;
                }
                c.x = i - 0.5 * c.width;
            }
            if (this.uv != null && this.u4 != null && this.u3 != null && b < this.u4.count && b < this.u3.count) {
                var j = this.uv.ej(this.u4.item(b), h);
                var k = this.uv.ej(this.u3.item(b), h);
                if (!isNaN_(j) && !isNaN_(k)) {
                    var l = Math.abs(j - k);
                    if (c.height < l) {
                        c.height = l;
                        c.y = Math.min(j, k);
                    }
                    else {
                        if (j < c.top + 0.1 * c.height) {
                            j = j + 0.4 * c.height;
                        }
                        if (j > c.bottom - 0.1 * c.height) {
                            j = j - 0.4 * c.height;
                        }
                        c.y = j - 0.5 * c.height;
                    }
                }
            }
            this.cr.au(this.cy, c, true);
        }
        return b >= 0;
    };
    FinancialOverlay.prototype.aq = function (a) {
        if (a != null && a == this.uv && this.u4 != null && this.u3 != null) {
            return new AxisRange(this.u4.minimum, this.u3.maximum);
        }
        return null;
    };
    FinancialOverlay.$t = markType(FinancialOverlay, 'FinancialOverlay', FinancialSeries.$);
    FinancialOverlay.$$p = markDep(DependencyProperty, PropertyMetadata, FinancialOverlay, 'raisePropertyChanged', ['IgnoreFirst:x5:x7', [1, 0]]);
    return FinancialOverlay;
}(FinancialSeries));
export { FinancialOverlay };
