/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { Series } from "./Series";
import { IHasCategoryModePreference_$type } from "./IHasCategoryModePreference";
import { Axis } from "./Axis";
import { DependencyProperty } from "igniteui-angular-core";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { Point_$type, typeCast, Delegate_$type, markType, markDep } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { Thickness } from "igniteui-angular-core";
import { AxisAnnotationFrame } from "./AxisAnnotationFrame";
import { List$1 } from "igniteui-angular-core";
import { Dictionary$2 } from "igniteui-angular-core";
import { Pool$1 } from "igniteui-angular-core";
import { AxisAnnotation } from "./AxisAnnotation";
import { SeriesView } from "./SeriesView";
import { NotImplementedException } from "igniteui-angular-core";
import { AxisRange } from "./AxisRange";
import { NumericAxisBase } from "./NumericAxisBase";
import { ScalerParams } from "./ScalerParams";
import { CategoryXAxis } from "./CategoryXAxis";
import { AxisAnnotationFrameManager } from "./AxisAnnotationFrameManager";
import { PropertyMetadata } from "igniteui-angular-core";
import { DeviceUtils } from "igniteui-angular-core";
import { isNaN_, isInfinity } from "igniteui-angular-core";
import { stringFormat } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
/**
 * @hidden
 */
var ValueOverlay = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ValueOverlay, _super);
    function ValueOverlay() {
        var _this = _super.call(this) || this;
        _this.ui = 0;
        _this.uj = 0;
        _this.uf = 0;
        _this.t2 = null;
        _this.t8 = null;
        _this.t7 = null;
        _this.ab = ValueOverlay.$;
        return _this;
    }
    ValueOverlay.prototype.h9 = function (a, b, c) {
        return this.uk;
    };
    ValueOverlay.prototype.ug = function (a, b) {
        var c = Math.sqrt(Math.pow(a.x - b.x, 2) + Math.pow(a.y - b.y, 2));
        var d = Math.acos((a.x - b.x) / c);
        if ((a.y - b.y) < 0) {
            d = (2 * Math.PI) - d;
        }
        return d;
    };
    ValueOverlay.prototype.th = function (a, b, c) {
        if (this.t1 == null) {
            return { $type: Point_$type, x: NaN, y: NaN };
        }
        var d = this.uh();
        var e = NaN;
        var f = NaN;
        var g = NaN;
        var h = { $type: Point_$type, x: 0.5, y: 0.5 };
        var i = NaN;
        switch (this.t1.a2) {
            case 2:
                i = Math.sqrt(Math.pow(a.x - h.x, 2) + Math.pow(a.y - h.y, 2));
                g = d;
                e = h.x + Math.cos(g) * i;
                f = h.y + Math.sin(g) * i;
                f = this.cj.bx.top + this.cj.bx.height * (f - this.cj.by.top) / this.cj.by.height;
                e = this.cj.bx.left + this.cj.bx.width * (e - this.cj.by.left) / this.cj.by.width;
                break;
            case 0:
                e = d;
                f = a.y;
                f = this.cj.bx.top + this.cj.bx.height * (f - this.cj.by.top) / this.cj.by.height;
                break;
            case 1:
                f = d;
                e = a.x;
                e = this.cj.bx.left + this.cj.bx.width * (e - this.cj.by.left) / this.cj.by.width;
                break;
            case 3:
                g = this.ug(a, h);
                i = d;
                e = h.x + Math.cos(g) * i;
                f = h.y + Math.sin(g) * i;
                f = this.cj.bx.top + this.cj.bx.height * (f - this.cj.by.top) / this.cj.by.height;
                e = this.cj.bx.left + this.cj.bx.width * (e - this.cj.by.left) / this.cj.by.width;
                break;
        }
        return { $type: Point_$type, x: e, y: f };
    };
    ValueOverlay.prototype.i8 = function (a) {
        throw new NotImplementedException(0);
    };
    ValueOverlay.prototype.jr = function (a) {
        return this;
    };
    ValueOverlay.prototype.fo = function (a) {
        return false;
    };
    ValueOverlay.prototype.aq = function (a) {
        var b = typeCast(NumericAxisBase.$, a);
        var c = this.uk;
        if (isNaN_(c) || isInfinity(c)) {
            return null;
        }
        return new AxisRange(c, c);
    };
    ValueOverlay.prototype.pq = function (a) {
        this.nj(true, this.cj);
        if (!this.t6()) {
            if (this.t2 != null) {
                this.u3(NaN, this.dj());
            }
            return;
        }
        if (this.fp(a)) {
            if (this.dj()) {
                if (this.cz.g) {
                    this.cz.t();
                }
                var b = this.ui;
                this.ui = this.uj;
                this.uj = b;
            }
            else {
                this.ui = this.uf;
            }
            this.uf = this.uh();
            this.p3();
        }
        else {
            this.uf = this.uh();
            this.u2(this.uf, this.t4);
        }
    };
    ValueOverlay.prototype.uh = function () {
        var a, b;
        var c = this.getViewInfo(b, a);
        b = c.p0;
        a = c.p1;
        var d = this.getEffectiveViewport1(this.cj);
        var e = new ScalerParams(0, a, b, this.t1.ch, d);
        return this.t1.ej(this.uk, e);
    };
    ValueOverlay.prototype.u2 = function (a, b) {
        if (this.t1 == null) {
            return;
        }
        var c = typeCast(CategoryAxisBase.$, this.t1);
        if (c != null && !c.ce) {
            if (this.uk > c.lg - 1) {
                return;
            }
            if (c.categoryMode != 0) {
                var d = this.getEffectiveViewport1(b);
                var e = 0.5 * c.getCategorySize(b.by, b.bx, d);
                var f = false;
                if (c.cp && !c.ch) {
                    f = true;
                }
                if (typeCast(CategoryXAxis.$, c) !== null && c.ch) {
                    f = true;
                }
                if (f) {
                    e = -e;
                }
                a += e;
            }
        }
        var g = typeCast(NumericAxisBase.$, this.t1);
        if (g != null) {
            if (this.uk < g.lx || this.uk > g.lw) {
                return;
            }
            if (g.lj && this.uk < 0) {
                return;
            }
        }
        var h;
        switch (this.t1.a2) {
            case 2:
            case 3:
                h = this.t1.j5(a, b.by, b.bx, this.getEffectiveViewport1(b), this.to(b));
                break;
            default:
                h = this.t1.j5(a, b.by, b.bx);
                break;
        }
        if (h != null) {
            b.b1(h);
        }
        if (!b.q) {
            this.u3(a, this.dj());
        }
    };
    ValueOverlay.prototype.gl = function (a, b, c) {
        var d = true;
        d = _super.prototype.gl.call(this, a, b, c);
        if (!c.o() || b.isEmpty || a.isEmpty || this.t1 == null || this.t1.bi == null) {
            d = false;
        }
        return d;
    };
    ValueOverlay.prototype.qn = function (a, b) {
        this.pp(false);
    };
    ValueOverlay.prototype.qm = function (a, b) {
        this.pp(false);
    };
    ValueOverlay.prototype.no = function (a, b, c, d) {
        throw new NotImplementedException(0);
    };
    ValueOverlay.prototype.o8 = function (a, b, c, d) {
        _super.prototype.o8.call(this, a, b, c, d);
        switch (b) {
            case ValueOverlay.$$p[11]:
                if (c != null) {
                    c.b0(this);
                }
                if (d != null) {
                    d.ct(this);
                }
                this.pp(false);
                this.ol();
                break;
            case "TransitionProgress":
                this.uj = this.ui + this.iv * (this.uf - this.ui);
                if (this.dl(this.cj)) {
                    return;
                }
                if (this.iv == 1) {
                    this.u2(this.uf, this.t4);
                }
                else {
                    this.u2(this.uj, this.t4);
                }
                if (this.cy != null) {
                    this.cy.on(this);
                }
                break;
            case ValueOverlay.$$p[13]:
                var e = typeCast(NumericAxisBase.$, this.t1);
                if (e != null) {
                    e.c1();
                }
                this.pp(true);
                this.om();
                break;
            case ValueOverlay.$$p[12]:
            case ValueOverlay.$$p[10]:
            case ValueOverlay.$$p[1]:
            case ValueOverlay.$$p[0]:
            case ValueOverlay.$$p[3]:
            case ValueOverlay.$$p[4]:
            case ValueOverlay.$$p[9]:
            case ValueOverlay.$$p[5]:
            case ValueOverlay.$$p[6]:
            case ValueOverlay.$$p[7]:
            case ValueOverlay.$$p[8]:
                this.pp(true);
                break;
        }
    };
    ValueOverlay.prototype.ob = function () {
        _super.prototype.ob.call(this);
        if (this.t1 != null) {
            this.t1.h8(false);
        }
    };
    ValueOverlay.prototype.nj = function (a, b) {
        _super.prototype.nj.call(this, a, b);
        var c = b;
        c.b0();
    };
    ValueOverlay.prototype.t6 = function () {
        if (this.t1 == null || this.t1.bi == null || isNaN_(this.uk) || this._visibility != 0) {
            return false;
        }
        var a = typeCast(CategoryAxisBase.$, this.t1);
        if (a != null && a.lg == 0) {
            return false;
        }
        return true;
    };
    ValueOverlay.prototype.preferredCategoryMode = function (a) {
        return 0;
    };
    Object.defineProperty(ValueOverlay.prototype, "categoryAxis", {
        get: function () {
            return typeCast(CategoryAxisBase.$, this.t1);
        },
        enumerable: false,
        configurable: true
    });
    ValueOverlay.prototype.cg = function () {
        return new ValueOverlayView(this);
    };
    ValueOverlay.prototype.o0 = function (a) {
        _super.prototype.o0.call(this, a);
        this.t4 = typeCast(ValueOverlayView.$, a);
    };
    ValueOverlay.prototype.pr = function (a, b) {
        _super.prototype.pr.call(this, a, b);
        if (!this.f8) {
            this.cj.a4(b);
            return;
        }
        this.cj.a4(b);
        if (this.dl(this.ci) || !this.t6()) {
            return;
        }
        var c = this.getEffectiveViewport1(this.cj);
        var d = this.t1.ej(this.uk, new ScalerParams(0, this.ci.by, a, this.t1.ch, c));
        this.u2(d, typeCast(ValueOverlayView.$, this.ci));
        this.f8 = false;
    };
    ValueOverlay.prototype.getOffsetValue = function () {
        return 0;
    };
    ValueOverlay.prototype.getCategoryWidth = function () {
        return 0;
    };
    Object.defineProperty(ValueOverlay.prototype, "vl", {
        get: function () {
            return new Thickness(1, this.ub, this.ud, this.uc, this.ua);
        },
        enumerable: false,
        configurable: true
    });
    ValueOverlay.prototype.ag = function () {
        return [this.t1];
    };
    ValueOverlay.prototype.u3 = function (a, b) {
        if (isNaN_(a)) {
            if (this.t2 != null) {
                AxisAnnotationFrameManager.b(this.t2);
                AxisAnnotationFrameManager.d(this, this.t2, true, this.t7, this.t8, b, this.ul, this.ul, this.t3, this.t3);
            }
            return;
        }
        var c = false;
        if (this.t7 == null) {
            c = true;
            this.t8 = new List$1(Axis.$, 0);
            this.t7 = new Dictionary$2(Axis.$, Pool$1.$.specialize(AxisAnnotation.$), 0);
        }
        this.t2 = new AxisAnnotationFrame();
        var d = this.ss;
        if (d == null) {
            d = this.sw;
        }
        var e = this.t1.cp;
        AxisAnnotationFrameManager.c(this.t2, { $type: Point_$type, x: a, y: a }, this, this.cy, this.getEffectiveViewport(), d, this.vi, this.t9, this.vk, this.vj, this.vl, this.ue, this.vi, this.t9, this.vk, this.vj, this.vl, this.ue, !e && this.t5, e && this.t5);
        AxisAnnotationFrameManager.d(this, this.t2, c, this.t7, this.t8, b, this.ul, this.ul, this.t3, this.t3);
    };
    ValueOverlay.prototype.get_isValueOverlay = function () {
        return true;
    };
    ValueOverlay.prototype.uy = function (a) {
        if (this.t1 != null) {
            return this.t1.gd(a);
        }
        return null;
    };
    Object.defineProperty(ValueOverlay.prototype, "u0", {
        get: function () {
            var a = this.uy(this.uk);
            return a != null ? a : stringFormat("{0:0.##}", this.uk);
        },
        enumerable: false,
        configurable: true
    });
    ValueOverlay.$t = markType(ValueOverlay, 'ValueOverlay', Series.$, [IHasCategoryModePreference_$type]);
    ValueOverlay.$$p = markDep(DependencyProperty, PropertyMetadata, ValueOverlay, 'raisePropertyChanged', ['AxisAnnotationBackgroundCornerRadius:t9:u4', [1, DeviceUtils.g(3)], 'AxisAnnotationBackground:vi:u5', [Brush.$, null], 'AxisAnnotationFormatLabel:t3:u6', [Delegate_$type], 'AxisAnnotationInterpolatedValuePrecision:ul:u7', [1, -1], 'AxisAnnotationOutline:vj:u8', [Brush.$, null], 'AxisAnnotationPaddingBottom:ua:u9', [1, NaN], 'AxisAnnotationPaddingLeft:ub:va', [1, NaN], 'AxisAnnotationPaddingRight:uc:vb', [1, NaN], 'AxisAnnotationPaddingTop:ud:vc', [1, NaN], 'AxisAnnotationStrokeThickness:ue:vd', [1, NaN], 'AxisAnnotationTextColor:vk:ve', [Brush.$, null], 'Axis:t1:vf', [Axis.$, null], 'IsAxisAnnotationEnabled:t5:vg', [0, false], 'Value:uk:vh', [1, 0]]);
    return ValueOverlay;
}(Series));
export { ValueOverlay };
/**
 * @hidden
 */
var ValueOverlayView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ValueOverlayView, _super);
    function ValueOverlayView(a) {
        var _this = _super.call(this, a) || this;
        _this.b2 = null;
        _this.b2 = new Path();
        return _this;
    }
    ValueOverlayView.prototype.bd = function () {
        _super.prototype.bd.call(this);
        this.b2._stroke = this.e.ss;
        this.b2.ad = this.e.hk;
        this.b2.ai = this.e.s7;
        this.b2.aj = this.e.s8;
    };
    ValueOverlayView.prototype.be = function () {
        _super.prototype.be.call(this);
        var a = this.br();
        this.b2._stroke = a;
        this.b2.ad = this.e.hk + 3;
        this.b2._stroke = a;
        this.b2.ad = this.e.hk + 3;
    };
    ValueOverlayView.prototype.b1 = function (a) {
        this.b2.an = a;
        this.as();
    };
    ValueOverlayView.prototype.b0 = function () {
        this.b2.an = null;
        this.as();
    };
    ValueOverlayView.prototype.a8 = function (a, b) {
        _super.prototype.a8.call(this, a, b);
        if (a.d) {
            a.t(this.b2);
        }
    };
    ValueOverlayView.prototype.an = function (a) {
        _super.prototype.an.call(this, a);
        this.e.a9.exportPathData(a, this.b2, "ValueOverlayPath", []);
    };
    ValueOverlayView.$t = markType(ValueOverlayView, 'ValueOverlayView', SeriesView.$);
    return ValueOverlayView;
}(SeriesView));
export { ValueOverlayView };
