import { Series } from "./Series";
import { Point, Type } from "igniteui-angular-core";
import { AnnotationAppearanceMode } from "./AnnotationAppearanceMode";
import { DoubleCollection } from "igniteui-angular-core";
import { Frame } from "./Frame";
import { SeriesView } from "./SeriesView";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { NotifyCollectionChangedEventArgs } from "igniteui-angular-core";
import { Axis } from "./Axis";
import { Brush } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { Tuple$2 } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare abstract class AnnotationLayer extends Series {
    static $t: Type;
    constructor();
    protected cg(): SeriesView;
    o0(a: SeriesView): void;
    protected ul(a: Series): boolean;
    protected ud: AnnotationLayerView;
    un: boolean;
    uo: boolean;
    wy: Point;
    ui: boolean;
    protected get_ef(): boolean;
    t4: AnnotationAppearanceMode;
    t1: AnnotationAppearanceMode;
    u1: number;
    uq: number;
    ub: AnnotationAppearanceMode;
    t2: AnnotationAppearanceMode;
    uc: AnnotationAppearanceMode;
    t3: AnnotationAppearanceMode;
    u0: number;
    up: number;
    u2: number;
    ur: number;
    wv: DoubleCollection;
    wp: DoubleCollection;
    ww: DoubleCollection;
    wq: DoubleCollection;
    protected bx(): SeriesHitTestMode;
    protected get_et(): boolean;
    protected get_isUsableInLegend(): boolean;
    protected o8(a: any, b: string, c: any, d: any): void;
    protected wz: Point;
    private v1;
    private v0;
    private vw;
    private vv;
    protected uj(a: Axis): boolean;
    private vp;
    protected uk(a: Series): boolean;
    private vz;
    protected vr(a: Axis, b: boolean): void;
    protected vs(a: Series, b: boolean): void;
    private vy;
    private vo;
    protected wn(): Brush;
    protected wo(): Brush;
    protected vq(a: NotifyCollectionChangedEventArgs): void;
    protected vt(a: NotifyCollectionChangedEventArgs): void;
    protected uf: Frame;
    protected ue: Frame;
    protected ug: Frame;
    protected qn(a: Rect, b: Rect): void;
    protected qm(a: Rect, b: Rect): void;
    pq(a: boolean): void;
    protected get_d6(): boolean;
    protected vu(a: Frame, b: SeriesView): void;
    protected vx(a: Frame, b: SeriesView): void;
    protected vn(a: Series): Tuple$2<boolean, Point>;
    protected oq(a: Point): void;
    wx: Point;
    gl(a: Rect, b: Rect, c: SeriesView): boolean;
    protected uy(): number;
    protected ux(): number;
    protected uz(): number;
    protected t8(): AnnotationAppearanceMode;
    protected t9(): AnnotationAppearanceMode;
    protected ua(): AnnotationAppearanceMode;
    protected wt(): DoubleCollection;
    protected wu(): DoubleCollection;
    protected t5(): AnnotationAppearanceMode;
    protected t6(): AnnotationAppearanceMode;
    protected t7(): AnnotationAppearanceMode;
    protected us(): number;
    protected uv(): number;
    protected uu(): number;
    protected ut(): number;
    protected uw(): number;
    protected wr(): DoubleCollection;
    protected ws(): DoubleCollection;
    protected v2(): void;
    protected get_gh(): boolean;
    private uh;
    get um(): boolean;
    set um(a: boolean);
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class AnnotationLayerView extends SeriesView {
    static $t: Type;
    constructor(a: AnnotationLayer);
    protected b0: AnnotationLayer;
    private b1;
    private b2;
    private b6;
    b3(): void;
    b5(): void;
    b4(): void;
}
