import { AnnotationLayer } from "./AnnotationLayer";
import { Brush } from "igniteui-angular-core";
import { Series } from "./Series";
import { Thickness } from "igniteui-angular-core";
import { Visibility } from "igniteui-angular-core";
import { CrosshairLayerFrame } from "./CrosshairLayerFrame";
import { List$1 } from "igniteui-angular-core";
import { Pool$1 } from "igniteui-angular-core";
import { Type } from "igniteui-angular-core";
import { SeriesView } from "./SeriesView";
import { Frame } from "./Frame";
import { AnnotationAppearanceMode } from "./AnnotationAppearanceMode";
import { DoubleCollection } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { RenderingContext } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class CrosshairLayer extends AnnotationLayer {
    static $t: Type;
    protected get_d5(): boolean;
    protected get_d3(): boolean;
    constructor();
    protected cg(): SeriesView;
    o0(a: SeriesView): void;
    protected w2: CrosshairLayerView;
    zf: Brush;
    zg: Brush;
    xt: string;
    w3: Series;
    w8: boolean;
    w6: boolean;
    xAxisAnnotationFormatLabel: (item: any) => string;
    w4(): boolean;
    yAxisAnnotationFormatLabel: (item: any) => string;
    w5(): boolean;
    zj: Brush;
    zh: Brush;
    xb: number;
    xn: number;
    zi: Brush;
    get zp(): Thickness;
    xd: number;
    xf: number;
    xe: number;
    xc: number;
    get zq(): Thickness;
    xj: number;
    xl: number;
    xk: number;
    xi: number;
    xg: number;
    zm: Brush;
    zk: Brush;
    xh: number;
    xo: number;
    zl: Brush;
    xm: number;
    zs: Visibility;
    zr: Visibility;
    w7: boolean;
    protected vs(a: Series, b: boolean): void;
    protected vu(a: Frame, b: SeriesView): void;
    protected ul(a: Series): boolean;
    oo(): void;
    protected t5(): AnnotationAppearanceMode;
    protected us(): number;
    protected uv(): number;
    protected uu(): number;
    protected wr(): DoubleCollection;
    protected ws(): DoubleCollection;
    private zn;
    private zo;
    private yk;
    private xa;
    private w9;
    protected yl(a: CrosshairLayerFrame, b: boolean): void;
    private yj;
    protected vx(a: Frame, b: SeriesView): void;
    protected fm(): boolean;
    protected o8(a: any, b: string, c: any, d: any): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class CrosshairLayerView extends AnnotationLayerView {
    static $t: Type;
    constructor(a: CrosshairLayer);
    protected b7: CrosshairLayer;
    b8: Pool$1<Path>;
    protected b9: List$1<Path>;
    au(): void;
    private ch;
    private ca;
    private cc;
    private cb;
    cd(a: Path, b: number, c: number, d: number): void;
    ce(a: Brush, b: number): Brush;
    cg(a: Brush, b: number): Brush;
    cf(a: Brush, b: number): Brush;
    protected a8(a: RenderingContext, b: boolean): void;
    an(a: any): void;
}
