import { AnnotationLayer } from "./AnnotationLayer";
import { Axis } from "./Axis";
import { DataToolTipLayerGroupingMode } from "igniteui-angular-core";
import { Series } from "./Series";
import { Rect } from "igniteui-angular-core";
import { Point, Type } from "igniteui-angular-core";
import { Size } from "igniteui-angular-core";
import { SeriesView } from "./SeriesView";
import { DataTooltipGroupedPositionX } from "igniteui-angular-core";
import { DataTooltipGroupedPositionY } from "igniteui-angular-core";
import { DataAbbreviationMode } from "igniteui-angular-core";
import { DataLegendValueMode } from "igniteui-angular-core";
import { Thickness } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { FontInfo } from "igniteui-angular-core";
import { DataLegendHeaderDateMode } from "igniteui-angular-core";
import { DataLegendHeaderTimeMode } from "igniteui-angular-core";
import { DataLegendSummaryType } from "igniteui-angular-core";
import { LegendItemBadgeShape } from "igniteui-angular-core";
import { DataLegendUnitsMode } from "igniteui-angular-core";
import { DataLegendLabelMode } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { IDataLegend } from "igniteui-angular-core";
import { Frame } from "./Frame";
import { Pool$1 } from "igniteui-angular-core";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { PointerTooltip } from "./PointerTooltip";
import { RenderingContext } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class DataToolTipLayer extends AnnotationLayer {
    static $t: Type;
    protected get_d5(): boolean;
    constructor();
    protected cg(): SeriesView;
    o0(a: SeriesView): void;
    protected xt: DataToolTipLayerView;
    protected get_eg(): boolean;
    w9: Axis;
    yn: boolean;
    xr: DataToolTipLayerGroupingMode;
    private xp;
    get xq(): DataToolTipLayerGroupingMode;
    set xq(a: DataToolTipLayerGroupingMode);
    private xs;
    protected o8(a: any, b: string, c: any, d: any): void;
    private yr;
    private ys;
    private ab9;
    acd(a: string, b: any): void;
    private aca;
    protected vr(a: Axis, b: boolean): void;
    protected vs(a: Series, b: boolean): void;
    protected vu(a: Frame, b: SeriesView): void;
    private yt;
    private w8;
    private xu;
    n8(): void;
    n9(): void;
    get aed(): Rect;
    get aec(): Rect;
    get aeb(): Rect;
    get aef(): Rect;
    private aee;
    private yj;
    private yg;
    private yh;
    private yi;
    private zm;
    private zk;
    private zl;
    private zv;
    private zt;
    private zu;
    private zp;
    private zn;
    private zo;
    private y5;
    private y7;
    private y6;
    private ze;
    private zg;
    private zf;
    private zb;
    private zd;
    private zc;
    private y1;
    private y8;
    private y9;
    private za;
    private y2;
    private y3;
    private y4;
    private zj;
    private zi;
    private zh;
    private zs;
    private zr;
    private zq;
    private y0;
    private aea;
    private yz;
    private yy;
    private w3;
    private w2;
    private yk;
    private yl;
    private ab8;
    private ye;
    private acc;
    private acb;
    private zy;
    protected vx(a: Frame, b: SeriesView): void;
    protected fm(): boolean;
    yw: number;
    yx: number;
    yu: number;
    yv: number;
    xj: DataTooltipGroupedPositionX;
    private xh;
    get xi(): DataTooltipGroupedPositionX;
    set xi(a: DataTooltipGroupedPositionX);
    private xk;
    xn: DataTooltipGroupedPositionY;
    private xl;
    get xm(): DataTooltipGroupedPositionY;
    set xm(a: DataTooltipGroupedPositionY);
    private xo;
    ym: boolean;
    w6: string[];
    w1: string[];
    w5: string[];
    w0: string[];
    xa: DataAbbreviationMode;
    zw: number;
    zx: number;
    xg: DataLegendValueMode;
    abr: string;
    yo: boolean;
    abx: string;
    w7: any[];
    aeo: Thickness;
    yp: boolean;
    ab6: string;
    yq: boolean;
    aep: Thickness;
    ad9: Brush;
    private x4;
    get yd(): FontInfo;
    set yd(a: FontInfo);
    aaf: string;
    w4: any[];
    aab: string;
    xb: DataLegendHeaderDateMode;
    xc: DataLegendHeaderTimeMode;
    aak: string;
    ad1: Brush;
    aei: Thickness;
    aeh: Thickness;
    yf: boolean;
    private xw;
    get x5(): FontInfo;
    set x5(a: FontInfo);
    ad4: Brush;
    private xz;
    get x8(): FontInfo;
    set x8(a: FontInfo);
    xe: DataLegendSummaryType;
    aa3: string;
    ael: Thickness;
    aek: Thickness;
    ad6: Brush;
    private x1;
    get ya(): FontInfo;
    set ya(a: FontInfo);
    aay: string;
    ad3: Brush;
    private xy;
    get x7(): FontInfo;
    set x7(a: FontInfo);
    aa9: string;
    ad5: Brush;
    private x0;
    get x9(): FontInfo;
    set x9(a: FontInfo);
    aeg: Thickness;
    xv: LegendItemBadgeShape;
    xf: DataLegendUnitsMode;
    abk: string;
    ad8: Brush;
    aen: Thickness;
    private x3;
    get yc(): FontInfo;
    set yc(a: FontInfo);
    aem: Thickness;
    ad7: Brush;
    private x2;
    get yb(): FontInfo;
    set yb(a: FontInfo);
    xd: DataLegendLabelMode;
    ad2: Brush;
    aej: Thickness;
    private xx;
    get x6(): FontInfo;
    set x6(a: FontInfo);
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class DataToolTipLayerView extends AnnotationLayerView {
    static $t: Type;
    constructor(a: DataToolTipLayer);
    b9: Pool$1<any>;
    ak(): void;
    protected cc: List$1<PointerTooltip>;
    private cd;
    private cf;
    private ch;
    private cg;
    protected b7: DataToolTipLayer;
    private ca;
    au(): void;
    private _htmlTest;
    protected get htmlTest(): any;
    protected set htmlTest(a: any);
    cb(a: any, b: Series): boolean;
    cq(a: any): Size;
    cp(): Rect;
    co(): Rect;
    cn(): Rect;
    cm(a: Point): Point;
    ck(a: any, b: number, c: number, d: number, e: number): void;
    cr(): Size;
    ci(a: any): void;
    cl(): void;
    protected a8(a: RenderingContext, b: boolean): void;
    an(a: any): void;
    b8(a: any): IDataLegend;
    cj(a: boolean): void;
}
