import { StackedBarSeries } from "./StackedBarSeries";
import { IStacked100Series } from "./IStacked100Series";
import { Type } from "igniteui-angular-core";
import { SeriesView } from "./SeriesView";
import { CategorySeriesView } from "./CategorySeriesView";
import { StackedBarSeriesView } from "./StackedBarSeriesView";
import { CategoryBucketCalculator } from "./CategoryBucketCalculator";
/**
 * @hidden
 */
export declare class Stacked100BarSeries extends StackedBarSeries implements IStacked100Series {
    static $t: Type;
    protected get_xn(): boolean;
    protected ip(): number;
    constructor();
    ac(): void;
    protected cg(): SeriesView;
    yr: Stacked100BarSeriesView;
    o0(a: SeriesView): void;
    xf(): CategorySeriesView;
    protected x3(): void;
    get useHighMarkerFidelity(): boolean;
}
/**
 * @hidden
 */
export declare class Stacked100BarSeriesView extends StackedBarSeriesView {
    static $t: Type;
    c9: Stacked100BarSeries;
    constructor(a: Stacked100BarSeries);
    cv(): CategoryBucketCalculator;
    au(): void;
}
