import { AnnotationLayer } from "./AnnotationLayer";
import { ValueLayerValueMode } from "./ValueLayerValueMode";
import { Brush } from "igniteui-angular-core";
import { Series } from "./Series";
import { Axis } from "./Axis";
import { Thickness } from "igniteui-angular-core";
import { Visibility } from "igniteui-angular-core";
import { ValueLayerFrame } from "./ValueLayerFrame";
import { List$1 } from "igniteui-angular-core";
import { Pool$1 } from "igniteui-angular-core";
import { Type } from "igniteui-angular-core";
import { SeriesView } from "./SeriesView";
import { Frame } from "./Frame";
import { AnnotationAppearanceMode } from "./AnnotationAppearanceMode";
import { DoubleCollection } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { RenderingContext } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class ValueLayer extends AnnotationLayer {
    static $t: Type;
    protected get_d7(): boolean;
    constructor();
    protected cg(): SeriesView;
    o0(a: SeriesView): void;
    protected w6: ValueLayerView;
    w5: ValueLayerValueMode;
    zr: Brush;
    zs: Brush;
    x0: string;
    w3: Series;
    xx: string;
    w0: Axis;
    xc: boolean;
    w9: boolean;
    xAxisAnnotationFormatLabel: (item: any) => string;
    w7(): boolean;
    yAxisAnnotationFormatLabel: (item: any) => string;
    w8(): boolean;
    zv: Brush;
    zt: Brush;
    xf: number;
    xr: number;
    zu: Brush;
    get z1(): Thickness;
    xh: number;
    xj: number;
    xi: number;
    xg: number;
    get z2(): Thickness;
    xn: number;
    xp: number;
    xo: number;
    xm: number;
    xk: number;
    zy: Brush;
    zw: Brush;
    xl: number;
    xs: number;
    zx: Brush;
    xq: number;
    z4: Visibility;
    z3: Visibility;
    xb: boolean;
    protected vs(a: Series, b: boolean): void;
    protected vu(a: Frame, b: SeriesView): void;
    protected ul(a: Series): boolean;
    protected xa(a: Axis): boolean;
    oo(): void;
    private w4;
    protected t5(): AnnotationAppearanceMode;
    protected us(): number;
    protected uv(): number;
    protected uu(): number;
    protected wr(): DoubleCollection;
    protected ws(): DoubleCollection;
    private zz;
    private z0;
    private yt;
    private ys;
    private xe;
    private xd;
    protected yu(a: ValueLayerFrame, b: boolean): void;
    private yr;
    protected vx(a: Frame, b: SeriesView): void;
    protected fm(): boolean;
    protected o8(a: any, b: string, c: any, d: any): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class ValueLayerView extends AnnotationLayerView {
    static $t: Type;
    constructor(a: ValueLayer);
    protected b7: ValueLayer;
    b8: Pool$1<Path>;
    protected b9: List$1<Path>;
    au(): void;
    private ch;
    private ca;
    private cc;
    private cb;
    cd(a: Path, b: number, c: number, d: number): void;
    ce(a: Brush, b: number): Brush;
    cg(a: Brush, b: number): Brush;
    cf(a: Brush, b: number): Brush;
    protected a8(a: RenderingContext, b: boolean): void;
    an(a: any): void;
}
