/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StackedLineSeries } from "./StackedLineSeries";
import { IStacked100Series_$type } from "./IStacked100Series";
import { markType } from "igniteui-angular-core";
import { Stacked100DataPreparer } from "./Stacked100DataPreparer";
import { StackedLineSeriesView } from "./StackedLineSeriesView";
import { Defaults } from "./Defaults";
/**
 * @hidden
 */
export let Stacked100LineSeries = /*@__PURE__*/ (() => {
    class Stacked100LineSeries extends StackedLineSeries {
        constructor() {
            super();
            this.ab = Stacked100LineSeries.$;
        }
        cg() {
            return new Stacked100LineSeriesView(this);
        }
        o0(a) {
            super.o0(a);
            this.yl = a;
        }
        get_xn() {
            return true;
        }
        ac() {
            super.ac();
            this.pp(false);
        }
        x3() {
            super.x3();
            Stacked100DataPreparer.a(this);
        }
        get useHighMarkerFidelity() {
            return this.wi;
        }
    }
    Stacked100LineSeries.$t = markType(Stacked100LineSeries, 'Stacked100LineSeries', StackedLineSeries.$, [IStacked100Series_$type]);
    return Stacked100LineSeries;
})();
/**
 * @hidden
 */
export let Stacked100LineSeriesView = /*@__PURE__*/ (() => {
    class Stacked100LineSeriesView extends StackedLineSeriesView {
        constructor(a) {
            super(a);
        }
        au() {
            super.au();
            if (!this.q) {
                this.c3.ua = Defaults.e;
            }
        }
    }
    Stacked100LineSeriesView.$t = markType(Stacked100LineSeriesView, 'Stacked100LineSeriesView', StackedLineSeriesView.$);
    return Stacked100LineSeriesView;
})();
