/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { ScatterBase } from "./ScatterBase";
import { IScaleLegendSeries_$type } from "igniteui-angular-core";
import { ISupportsSizeScale_$type } from "./ISupportsSizeScale";
import { ISupportsFillScale_$type } from "./ISupportsFillScale";
import { List$1 } from "igniteui-angular-core";
import { UIElement } from "igniteui-angular-core";
import { Base, typeCast, Point_$type, fromEnum, markType, markDep, enumGetBox, runOn } from "igniteui-angular-core";
import { ActualRange } from "./ActualRange";
import { DependencyProperty } from "igniteui-angular-core";
import { SizeScale } from "./SizeScale";
import { BrushScale } from "./BrushScale";
import { ScatterFrame } from "./ScatterFrame";
import { IChartLegend_$type } from "igniteui-angular-core";
import { ValueBrushScale } from "./ValueBrushScale";
import { IFastItemsSource_$type } from "igniteui-angular-core";
import { ScatterBaseView } from "./ScatterBaseView";
import { ScalerParams } from "./ScalerParams";
import { OwnedPoint } from "./OwnedPoint";
import { Dictionary$2 } from "igniteui-angular-core";
import { BubbleMarkerManager } from "./BubbleMarkerManager";
import { IChartItemLegend_$type } from "igniteui-angular-core";
import { IChartScaleLegend_$type } from "igniteui-angular-core";
import { ContentControl } from "igniteui-angular-core";
import { DataContext } from "igniteui-angular-core";
import { DeviceUtils } from "igniteui-angular-core";
import { BrushUtil } from "igniteui-angular-core";
import { DataLegendSeriesValueInfo } from "igniteui-angular-core";
import { DataLegendSeriesContext } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { isNaN_, isInfinity, logBase } from "igniteui-angular-core";
import { stringIsNullOrEmpty } from "igniteui-angular-core";
import { BrushSelectionMode_$type } from "./BrushSelectionMode";
import { ScatterTrendLineManager } from "./ScatterTrendLineManager";
import { Defaults } from "./Defaults";
/**
 * @hidden
 */
var BubbleSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(BubbleSeries, _super);
    function BubbleSeries() {
        var _this = _super.call(this) || this;
        _this.aa7 = null;
        _this.aa6 = null;
        _this.zu = null;
        _this.zm = null;
        _this.zl = null;
        _this.zk = null;
        _this.zi = null;
        _this.ab = BubbleSeries.$;
        _this.v0 = new ScatterFrame();
        _this.v2 = new ScatterFrame();
        _this.vy = new ScatterFrame();
        return _this;
    }
    BubbleSeries.prototype.get_dx = function () {
        return true;
    };
    BubbleSeries.prototype.cg = function () {
        return new BubbleSeriesView(this);
    };
    BubbleSeries.prototype.o0 = function (a) {
        _super.prototype.o0.call(this, a);
        this.zh = a;
    };
    BubbleSeries.prototype.iq = function () {
        return 0.7;
    };
    BubbleSeries.prototype.t4 = function () {
        if (this.t3 == 0) {
            return 2;
        }
        return _super.prototype.t4.call(this);
    };
    BubbleSeries.prototype.isAttachedTo = function (a) {
        return this.a2 == a;
    };
    BubbleSeries.prototype.dw = function () {
        return true;
    };
    BubbleSeries.prototype.n4 = function (a) {
        _super.prototype.n4.call(this, a);
        if (this.zp != null && this.zu != null && this.zu.count > 0) {
            for (var b = 0; b < this.zu.count; b++) {
                a(this.zu._inner[b]);
            }
        }
    };
    Object.defineProperty(BubbleSeries.prototype, "zo", {
        get: function () {
            return this.zq;
        },
        enumerable: false,
        configurable: true
    });
    BubbleSeries.prototype.aa5 = function (a) {
        var b = typeCast(CustomPaletteBrushScale.$, this.zg);
        var c = typeCast(ValueBrushScale.$, this.zg);
        var d = this.zg;
        if (b != null && this.c6 != null) {
            return b.getBrush1(a, this.c6.count);
        }
        else if (c != null) {
            return c.getBrushByIndex(a, this.zn);
        }
        else if (d != null) {
            return d.getBrush(a);
        }
        return null;
    };
    Object.defineProperty(BubbleSeries.prototype, "legendReady", {
        get: function () {
            return this.zq != null && this.zq.count != 0;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BubbleSeries.prototype, "minScaleText", {
        get: function () {
            var a = this.zf(this.zj).b;
            return (Math.round(a * 1000) / 1000).toString();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BubbleSeries.prototype, "maxScaleText", {
        get: function () {
            var a = this.zf(this.zj).a;
            return (Math.round(a * 1000) / 1000).toString();
        },
        enumerable: false,
        configurable: true
    });
    BubbleSeries.prototype.forScaleColors = function (a) {
        for (var b = 0; b < this.zq.count; b++) {
            if (this.zg == null || !this.zg.isReady) {
                return false;
            }
            var c = NaN;
            if (this.zn != null) {
                c = (this.zn.item(b) - this.zn.minimum) / (this.zn.maximum - this.zn.minimum);
            }
            var d = (this.zq.item(b) - this.zq.minimum) / (this.zq.maximum - this.zq.minimum);
            if (isNaN_(c)) {
                c = 0;
            }
            if (isNaN_(d)) {
                d = c;
            }
            var e = this.va;
            var f = this.aa5(b);
            var g = f != null ? f : e;
            a(g, d);
        }
        return true;
    };
    BubbleSeries.prototype.ju = function (a, b) {
        var c = this.lv(b);
        if (c == BubbleSeries.$$p[5]) {
            return this.jv(a, b, this.z9);
        }
        if (c == BubbleSeries.$$p[11]) {
            return this.jv(a, b, this.aaj);
        }
        if (c == ScatterBase.$$p[12]) {
            return this.jv(a, b, this.xl);
        }
        if (c == ScatterBase.$$p[16]) {
            return this.jv(a, b, this.xt);
        }
        if (c == BubbleSeries.$$p[2]) {
            return this.jv(a, b, this.z4);
        }
        return _super.prototype.ju.call(this, a, b);
    };
    Object.defineProperty(BubbleSeries.prototype, "zq", {
        get: function () {
            return this.zm;
        },
        set: function (a) {
            if (this.zm != a) {
                var b = this.zq;
                this.zm = a;
                this.raisePropertyChanged("RadiusColumn", b, this.zq);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BubbleSeries.prototype, "zp", {
        get: function () {
            return this.zl;
        },
        set: function (a) {
            if (this.zl != a) {
                var b = this.zp;
                this.zl = a;
                this.raisePropertyChanged("LabelColumn", b, this.zp);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BubbleSeries.prototype, "zn", {
        get: function () {
            return this.zk;
        },
        set: function (a) {
            if (this.zk != a) {
                var b = this.zn;
                this.zk = a;
                this.raisePropertyChanged("FillColumn", b, this.zn);
            }
        },
        enumerable: false,
        configurable: true
    });
    BubbleSeries.prototype.xw = function (a, b, c, d, e) {
        if (c <= this.w1) {
            b.g = new Dictionary$2(Base.$, OwnedPoint.$, 1, c);
        }
        var f = this.w1;
        var g = this.c6;
        var h;
        var i;
        var j = this.getEffectiveViewport1(a);
        var k = new ScalerParams(0, d, e, this.vu.d, j);
        var l = new ScalerParams(0, d, e, this.vu.e, j);
        var m = false;
        var n = 0;
        if (this.cy != null) {
            if (this.cy.fb()) {
                var o = this.cy.lo(d, k);
                m = o.c;
                n = o.d;
            }
        }
        var _loop_1 = function (p) {
            h = this_1.wa.item(p);
            i = this_1.wb.item(p);
            var q = { $type: Point_$type, x: this_1.vu.a.ej(h, k), y: this_1.vu.b.ej(i, l) };
            if (m) {
                if (q.x < e.left || q.x > e.right) {
                    if (q.x + n >= e.left && q.x + n <= e.right) {
                        q = { $type: Point_$type, x: q.x + n, y: i };
                    }
                }
            }
            if (!isInfinity(q.x) && !isInfinity(q.y)) {
                var r_1 = g.item(p);
                if (c <= f) {
                    if (!b.g.containsKey(r_1)) {
                        var s_1 = { $type: Point_$type, x: h, y: i };
                        b.g.addItem(r_1, ((function () {
                            var $ret = new OwnedPoint();
                            $ret.a = r_1;
                            $ret.b = s_1;
                            $ret.c = q;
                            return $ret;
                        })()));
                    }
                }
            }
        };
        var this_1 = this;
        for (var p = 0; p < c; p++) {
            _loop_1(p);
        }
    };
    BubbleSeries.prototype.x6 = function (a, b) {
        var c = typeCast(BubbleSeriesView.$, b);
        var d = c.cy;
        d.m = this.zq;
        _super.prototype.x6.call(this, a, b);
        var e = Math.min(this.wa != null ? this.wa.count : 0, this.wb != null ? this.wb.count : 0);
        if (e < 1) {
            return;
        }
        c.dk();
        c.dl();
    };
    BubbleSeries.prototype.aao = function () {
        if (this.cy == null) {
            return;
        }
        if (this.a2 == null) {
            return;
        }
        if (this.a2.isItemwise) {
            var a = this.a2;
            this.a2.clearLegendItemsForSeries(this);
            this.aan();
            a.renderItemwiseContent(this);
        }
        if (this.a2.isScale) {
            var b = this.a2;
            b.restoreOriginalState();
            b.initializeLegend(this);
        }
    };
    BubbleSeries.zv = function (a, b, c, d, e) {
        if (e <= a || isNaN_(e) || isInfinity(e)) {
            return c;
        }
        if (e >= b) {
            return d;
        }
        var f = c + ((d - c) / (b - a)) * (e - a);
        return f;
    };
    BubbleSeries.zw = function (a, b, c, d, logBase_, e) {
        var f = logBase(e, logBase_);
        var g = logBase(a, logBase_);
        var h = logBase(b, logBase_);
        return BubbleSeries.zv(g, h, c, d, f);
    };
    BubbleSeries.prototype.gl = function (a, b, c) {
        var d = _super.prototype.gl.call(this, a, b, c);
        if (this.zq == null || this.c6 == null || this.zq.count == 0 || this.c6.count != this.zq.count) {
            d = false;
        }
        return d;
    };
    BubbleSeries.prototype.wk = function (a, b) {
        if (b != 3) {
            return true;
        }
        if (a == null) {
            return true;
        }
        if (this.xl == a || this.xt == a || this.aaj == a) {
            return true;
        }
        return false;
    };
    BubbleSeries.prototype.aan = function () {
        var _this = this;
        var a = typeCast(IChartLegend_$type, this.a2);
        if (a == null || this.c6 == null) {
            return;
        }
        this.zu = new List$1(UIElement.$, 0);
        var b = typeCast(CustomPaletteBrushScale.$, this.zg);
        var c = typeCast(ValueBrushScale.$, this.zg);
        var d = this.zg;
        var e = this.ze();
        var f = e.b;
        var g = e.a;
        var h = this.c6;
        var _loop_2 = function (i) {
            var j = null;
            if (c != null && this_2.zn != null) {
                var k = this_2.zn.item(i);
                j = c.getBrushByRange(k, f, g);
            }
            else if (b != null) {
                j = b.getBrush1(i, h.count);
            }
            else if (d != null) {
                j = d.getBrush(i);
            }
            var l = new ContentControl();
            var m = this_2.zp != null && this_2.zp.item(i) != null ? this_2.zp.item(i).toString() : "";
            l.content = ((function () {
                var $ret = new DataContext();
                $ret.series = _this;
                $ret.item = h.item(i);
                $ret.itemBrush = j;
                $ret.itemLabel = m;
                return $ret;
            })());
            var n = this_2.qt;
            if (n == null) {
                n = this_2.cj.bn(this_2.co);
            }
            l.ah = n;
            this_2.zu.add(l);
        };
        var this_2 = this;
        for (var i = 0; i < h.count; i++) {
            _loop_2(i);
        }
    };
    BubbleSeries.prototype.no = function (a, b, c, d) {
        _super.prototype.no.call(this, a, b, c, d);
        if (this.zj != null) {
            this.zj.aa();
        }
        if (this.zg != null) {
            this.zg.x();
        }
        this.aao();
    };
    BubbleSeries.prototype.oe = function () {
        _super.prototype.oe.call(this);
        this.aao();
    };
    BubbleSeries.prototype.ok = function () {
        _super.prototype.ok.call(this);
        this.aao();
    };
    BubbleSeries.prototype.o8 = function (a, b, c, d) {
        var e_1, _a;
        _super.prototype.o8.call(this, a, b, c, d);
        switch (b) {
            case "FastItemsSource":
                if (this.zj != null) {
                    this.zj.aa();
                }
                if (this.zg != null) {
                    this.zg.x();
                }
                if (typeCast(IFastItemsSource_$type, c) != null) {
                    c.deregisterColumn(this.zq);
                    c.deregisterColumn(this.zn);
                    c.deregisterColumn(this.zp);
                    this.zq = null;
                    this.zn = null;
                    this.zp = null;
                }
                if (typeCast(IFastItemsSource_$type, d) != null) {
                    this.zq = this.c3(this.aaj);
                    if (!stringIsNullOrEmpty(this.z4)) {
                        this.zn = this.c3(this.z4);
                    }
                    this.zp = this.c5(this.z9);
                }
                this.pp(false);
                this.aao();
                break;
            case BubbleSeries.$$p[11]:
                if (this.zj != null) {
                    this.zj.aa();
                }
                if (this.c6 != null) {
                    this.c6.deregisterColumn(this.zq);
                    this.zq = this.c3(this.aaj);
                    this.aao();
                }
                break;
            case "RadiusColumn":
                if (this.zj != null) {
                    this.zj.aa();
                }
                this.vv.c0.g$i();
                this.pp(this.fq && this.dn);
                this.om();
                break;
            case BubbleSeries.$$p[12]:
                if (c != null) {
                    c.l.remove(this);
                    c.aa();
                }
                if (d != null) {
                    d.l.add(this);
                    d.aa();
                }
                this.pp(false);
                this.ol();
                break;
            case BubbleSeries.$$p[13]:
                this.pp(false);
                this.ol();
                break;
            case "DiscreteLegendItemTemplate":
                this.aao();
                break;
            case BubbleSeries.$$p[3]:
                if (c != null) {
                    c.o.remove(this);
                    c.x();
                }
                if (d != null) {
                    d.o.add(this);
                    d.x();
                }
                this.pp(false);
                this.aao();
                this.ol();
                break;
            case BubbleSeries.$$p[4]:
            case BubbleSeries.$$p[8]:
            case BubbleSeries.$$p[7]:
            case BubbleSeries.$$p[6]:
                this.pp(false);
                this.aao();
                this.ol();
                break;
            case "FillColumn":
                this.pp(this.fq && this.dn);
                this.ol();
                break;
            case BubbleSeries.$$p[2]:
                if (this.zg != null) {
                    this.zg.x();
                }
                if (this.c6 != null) {
                    this.c6.deregisterColumn(this.zn);
                    this.zn = this.c3(this.z4);
                    this.aao();
                }
                break;
            case BubbleSeries.$$p[5]:
                if (this.c6 != null) {
                    this.c6.deregisterColumn(this.zp);
                    this.zp = this.c5(this.z9);
                    this.aao();
                }
                break;
            case "ActualLegend":
                var e = typeCast(IChartLegend_$type, c);
                if (e != null && e.isItemwise) {
                    var f = typeCast(IChartItemLegend_$type, e);
                    f.clearLegendItemsForSeries(this);
                }
                if (e != null && e.isScale) {
                    var g = typeCast(IChartScaleLegend_$type, e);
                    var h = true;
                    var i = null;
                    if (this.cy != null) {
                        try {
                            for (var _b = __values(fromEnum(this.cy.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                                var j = _c.value;
                                if (j.legend == g) {
                                    i = j;
                                    h = false;
                                }
                            }
                        }
                        catch (e_1_1) {
                            e_1 = { error: e_1_1 };
                        }
                        finally {
                            try {
                                if (_c && !_c.done && (_a = _b.return))
                                    _a.call(_b);
                            }
                            finally {
                                if (e_1)
                                    throw e_1.error;
                            }
                        }
                    }
                    if (h) {
                        g.restoreOriginalState();
                    }
                    else {
                        g.initializeLegend(typeCast(IScaleLegendSeries_$type, i));
                    }
                }
                this.aao();
                break;
            case "SeriesViewer":
                this.aao();
                break;
        }
    };
    BubbleSeries.prototype.updateSizeScaleGlobals = function () {
        var a = new ActualRange();
        a.b = NaN;
        a.a = NaN;
        if (this.zq != null) {
            a.b = this.zq.minimum;
            a.a = this.zq.maximum;
        }
        if (this.zj != null) {
            this.zj.ab(a.b, a.a);
        }
    };
    BubbleSeries.prototype.updateFillScaleGlobals = function () {
        var a = new ActualRange();
        a.b = NaN;
        a.a = NaN;
        if (this.zn != null) {
            a.b = this.zn.minimum;
            a.a = this.zn.maximum;
        }
        if (this.zg != null) {
            this.zg.z(a.b, a.a);
        }
    };
    BubbleSeries.prototype.zf = function (a) {
        var b = new ActualRange();
        b.b = NaN;
        b.a = NaN;
        if (this.zq != null) {
            b.b = this.zq.minimum;
            b.a = this.zq.maximum;
        }
        if (a != null) {
            a.x();
            if (this.zt) {
                b.b = a.globalMinimum;
                b.a = a.globalMaximum;
            }
        }
        return b;
    };
    BubbleSeries.prototype.ze = function () {
        var a = new ActualRange();
        a.b = NaN;
        a.a = NaN;
        if (this.zn != null) {
            a.b = this.zn.minimum;
            a.a = this.zn.maximum;
        }
        var b = typeCast(ValueBrushScale.$, this.zg);
        if (b != null) {
            b.s();
            if (this.zr && this.zg.o.count > 1) {
                a.b = b.q;
                a.a = b.p;
            }
        }
        return a;
    };
    BubbleSeries.prototype.aaq = function (a, b, c, d) {
        var e = c.width;
        if (!this.cj.bx.isEmpty) {
            e = this.cj.bx.width;
        }
        else if (this.cy != null && !this.cy.t2.isEmpty) {
            e = this.cy.t2.width;
        }
        var f = DeviceUtils.c(e);
        this.zi = this.zj || ((function () {
            var $ret = new SizeScale();
            $ret.minimumValue = f / 10;
            $ret.maximumValue = f / 5;
            return $ret;
        })());
        if (this.zi != null) {
            var g = this.zi.minimumValue;
            var h = this.zi.maximumValue;
            var i = this.zi.logarithmBase;
            var j = this.zf(this.zi);
            var k = j.b;
            var l = j.a;
            if (this.zi.isLogarithmic) {
                for (var m = 0; m < b.count; m++) {
                    b._inner[m] = BubbleSeries.zw(k, l, g, h, i, b._inner[m]);
                }
            }
            else {
                for (var n = 0; n < b.count; n++) {
                    b._inner[n] = BubbleSeries.zv(k, l, g, h, b._inner[n]);
                }
            }
        }
        var o = 1;
        o = DeviceUtils.d();
        var p = this.zj == null;
        if (d) {
            var q = c.width / e;
            for (var r = 0; r < b.count; r++) {
                if (p) {
                    b._inner[r] = b._inner[r] / o;
                }
                b._inner[r] = b._inner[r] * q;
            }
        }
        for (var s = 0; s < a.count; s++) {
            var t = a._inner[s];
            if (p && !d) {
                t.width = Math.max(0, b._inner[s] / o);
                t.height = Math.max(0, b._inner[s] / o);
            }
            else {
                t.width = Math.max(0, b._inner[s]);
                t.height = Math.max(0, b._inner[s]);
            }
        }
    };
    BubbleSeries.prototype.aap = function (a) {
        var b = typeCast(BubbleSeriesView.$, this.ci);
        this.zh.b6 = false;
        if (b != null) {
            b.b6 = false;
        }
        var c = typeCast(CustomPaletteBrushScale.$, this.zg);
        var d = typeCast(ValueBrushScale.$, this.zg);
        var e = this.zg;
        var f = this.ze();
        var g = f.b;
        var h = f.a;
        var i = this.zg == null || !this.zg.isReady || (d != null && this.z4 == null);
        if (i) {
            this.zh.dj();
            if (b != null) {
                b.dj();
            }
            return;
        }
        this.zh.b6 = true;
        if (b != null) {
            b.b6 = true;
        }
        var j = a.count;
        var k = this.c6;
        for (var l = 0; l < j; l++) {
            var m = a._inner[l];
            var n = typeCast(DataContext.$, m.content);
            if (n != null) {
                var o = null;
                var p = k.indexOf(n.item);
                if (c != null) {
                    o = c.getBrush1(p, k.count);
                }
                else if (d != null && this.zn != null) {
                    var q = this.zn.item(p);
                    o = d.getBrushByRange(q, g, h);
                }
                else if (e != null) {
                    o = e.getBrush(p);
                }
                else {
                    if (this.vc == null) {
                        o = this.va;
                    }
                    else {
                        o = this.vc;
                    }
                }
                var r = null;
                if (this.vd == null) {
                    r = this.vb;
                }
                else {
                    r = this.vd;
                }
                if (this.zs && o != null) {
                    r = o;
                }
                if (r != null && !isNaN_(this.zy)) {
                    r = BrushUtil.m(r, this.zy);
                }
                if (o != null && !isNaN_(this.zx)) {
                    o = BrushUtil.m(o, this.zx);
                }
                n.itemBrush = o;
                n.actualItemBrush = o;
                n.outline = r;
            }
        }
    };
    BubbleSeries.prototype.getDataLegendSeriesContextAt = function (a, b) {
        var c = { $type: Point_$type, x: a, y: b };
        var d = this.jr(c);
        var e = d == null ? NaN : this.h1(d, "XMemberPath");
        var f = d == null ? NaN : this.h1(d, "YMemberPath");
        var g = new DataLegendSeriesValueInfo();
        g.a = 13;
        g.l = e;
        g.p = "X";
        g.q = this.xl != null ? this.xl : "X";
        g.r = this.xh != null ? this.xh : "X:";
        g.s = this.xj != null ? this.xj : "";
        var h = new DataLegendSeriesValueInfo();
        h.l = f;
        h.a = 14;
        h.p = "Y";
        h.q = this.xt != null ? this.xt : "Y";
        h.r = this.xp != null ? this.xp : "Y:";
        h.s = this.xr != null ? this.xr : "";
        var i = new DataLegendSeriesContext();
        i.f = ((function () {
            var $ret = new List$1(DataLegendSeriesValueInfo.$, 0);
            $ret.add(g);
            $ret.add(h);
            return $ret;
        })());
        i.b = this.aw();
        if (!stringIsNullOrEmpty(this.aaj)) {
            var j = d == null ? NaN : this.h1(d, "RadiusMemberPath");
            var k = new DataLegendSeriesValueInfo();
            k.l = j;
            k.a = 11;
            k.p = "Radius";
            k.q = this.aaj != null ? this.aaj : "Radius";
            k.r = this.aaf != null ? this.aaf : "R:";
            k.s = this.aah != null ? this.aah : "";
            i.f.add(k);
        }
        else if (this.zi != null) {
            var l = new DataLegendSeriesValueInfo();
            l.l = this.zi.maximumValue;
            l.a = 11;
            l.p = "Radius";
            l.q = this.aaj != null ? this.aaj : "Radius";
            l.r = this.aaf != null ? this.aaf : "R:";
            l.s = this.aah != null ? this.aah : "";
            i.f.add(l);
        }
        if (!stringIsNullOrEmpty(this.z4)) {
            var m = d == null ? NaN : this.h1(d, "FillMemberPath");
            var n = new DataLegendSeriesValueInfo();
            n.l = m;
            n.a = 12;
            n.p = "Fill";
            n.q = this.z4 != null ? this.z4 : "Fill";
            n.r = this.z0 != null ? this.z0 : "F:";
            n.s = this.z2 != null ? this.z2 : "";
            i.f.add(n);
        }
        return i;
    };
    Object.defineProperty(BubbleSeries.prototype, "actualMarkerBrush", {
        get: function () {
            return this.va;
        },
        enumerable: false,
        configurable: true
    });
    BubbleSeries.$t = markType(BubbleSeries, 'BubbleSeries', ScatterBase.$, [IScaleLegendSeries_$type, ISupportsSizeScale_$type, ISupportsFillScale_$type]);
    BubbleSeries.$$p = markDep(DependencyProperty, PropertyMetadata, BubbleSeries, 'raisePropertyChanged', ['FillMemberAsLegendLabel:z0:aar', [2, null], 'FillMemberAsLegendUnit:z2:aas', [2, null], 'FillMemberPath:z4:aat', [2], 'FillScale:zg:aau', [BrushScale.$], 'FillScaleUseGlobalValues:zr:aav', [0, false], 'LabelMemberPath:z9:aaw', [2], 'MarkerBrushBrightness:zx:aax', [1, NaN], 'MarkerOutlineBrightness:zy:aay', [1, NaN], 'MarkerOutlineUsesFillScale:zs:aaz', [0, false], 'RadiusMemberAsLegendLabel:aaf:aa0', [2, null], 'RadiusMemberAsLegendUnit:aah:aa1', [2, null], 'RadiusMemberPath:aaj:aa2', [2, null], 'RadiusScale:zj:aa3', [SizeScale.$], 'RadiusScaleUseGlobalValues:zt:aa4', [0, false]]);
    return BubbleSeries;
}(ScatterBase));
export { BubbleSeries };
/**
 * @hidden
 */
var CustomPaletteBrushScale = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CustomPaletteBrushScale, _super);
    function CustomPaletteBrushScale() {
        return _super.call(this) || this;
    }
    CustomPaletteBrushScale.prototype.getBrush1 = function (a, b) {
        if (this.brushes == null || this.brushes.count == 0) {
            return null;
        }
        if (this.brushSelectionMode == 0) {
            return _super.prototype.getBrush.call(this, a % this.brushes.count);
        }
        var c = BubbleSeries.zv(0, b - 1, 0, this.brushes.count - 1, a);
        return this.ab(c);
    };
    CustomPaletteBrushScale.prototype.get_isReady = function () {
        return this.brushes != null && this.brushes.count > 0;
    };
    CustomPaletteBrushScale.$t = markType(CustomPaletteBrushScale, 'CustomPaletteBrushScale', BrushScale.$);
    CustomPaletteBrushScale.$$p = markDep(DependencyProperty, PropertyMetadata, CustomPaletteBrushScale, 'v', ['BrushSelectionMode', [BrushSelectionMode_$type, enumGetBox(BrushSelectionMode_$type, 0)]]);
    return CustomPaletteBrushScale;
}(BrushScale));
export { CustomPaletteBrushScale };
/**
 * @hidden
 */
var BubbleSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(BubbleSeriesView, _super);
    function BubbleSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.di = null;
        _this.di = a;
        _this.c0 = new ScatterTrendLineManager();
        return _this;
    }
    BubbleSeriesView.prototype.au = function () {
        _super.prototype.au.call(this);
        if (!this.q) {
            this.b4.ua = Defaults.e;
        }
    };
    BubbleSeriesView.prototype.cx = function () {
        var _this = this;
        return new BubbleMarkerManager(function (a) { return _this.c1.item(a); }, function (a) { return _this.cz.vu.c.item(a); }, runOn(this, this.dc), runOn(this, this.cu), runOn(this, this.c2));
    };
    BubbleSeriesView.prototype.dk = function () {
        var a = this.cy;
        this.di.aaq(a.n, a.o, this.bx, this == this.e.ci);
        this.as();
    };
    BubbleSeriesView.prototype.dl = function () {
        var a = this.cy;
        this.di.aap(a.n);
    };
    BubbleSeriesView.prototype.dj = function () {
        var e_2, _a;
        var a = this.cy;
        try {
            for (var _b = __values(fromEnum(a.n)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                var c = typeCast(DataContext.$, b.content);
                if (c != null) {
                    c.itemBrush = null;
                    c.outline = null;
                }
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
    };
    BubbleSeriesView.prototype.getDefaultTooltipTemplate = function () {
        var a = "<div class='ui-chart-default-tooltip-content'><span";
        var b = this.e.a7.a$r(this.e);
        if (!stringIsNullOrEmpty(b)) {
            a += " style='color:" + b + "'";
        }
        a += ">" + this.di.title + "</span><br/><span>" + "(${item." + this.di.xl + "}, ${item." + this.di.xt + "})</span>";
        if (!stringIsNullOrEmpty(this.di.aaj)) {
            a += "<span>, Radius: ${item." + this.di.aaj + "}</span>";
        }
        a += "</div>";
        return a;
    };
    BubbleSeriesView.$t = markType(BubbleSeriesView, 'BubbleSeriesView', ScatterBaseView.$);
    return BubbleSeriesView;
}(ScatterBaseView));
export { BubbleSeriesView };
