/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { AnnotationLayer } from "./AnnotationLayer";
import { DependencyProperty } from "igniteui-angular-core";
import { Series } from "./Series";
import { FinalValueSelectionMode_$type } from "./FinalValueSelectionMode";
import { Brush } from "igniteui-angular-core";
import { Thickness } from "igniteui-angular-core";
import { FinalValueLayerFrame } from "./FinalValueLayerFrame";
import { List$1 } from "igniteui-angular-core";
import { Axis } from "./Axis";
import { Dictionary$2 } from "igniteui-angular-core";
import { Pool$1 } from "igniteui-angular-core";
import { AxisAnnotation } from "./AxisAnnotation";
import { Base, enumGetBox, fromEnum, Point_$type, markType, markDep } from "igniteui-angular-core";
import { AxisAnnotationFrameManager } from "./AxisAnnotationFrameManager";
import { PropertyMetadata } from "igniteui-angular-core";
import { DeviceUtils } from "igniteui-angular-core";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { BrushUtil } from "igniteui-angular-core";
/**
 * @hidden
 */
var FinalValueLayer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinalValueLayer, _super);
    function FinalValueLayer() {
        var _this = _super.call(this) || this;
        _this.axisAnnotationFormatLabel = null;
        _this.w6 = null;
        _this.w5 = null;
        var a = new FinalValueLayerFrame();
        var b = new FinalValueLayerFrame();
        var c = new FinalValueLayerFrame();
        var d = _this.ji / 1000;
        _this.uf = a;
        _this.ue = b;
        _this.ug = c;
        _this.ab = FinalValueLayer.$;
        return _this;
    }
    FinalValueLayer.prototype.get_d4 = function () {
        return true;
    };
    FinalValueLayer.prototype.cg = function () {
        return new FinalValueLayerView(this);
    };
    FinalValueLayer.prototype.o0 = function (a) {
        _super.prototype.o0.call(this, a);
        this.w1 = a;
    };
    Object.defineProperty(FinalValueLayer.prototype, "yb", {
        get: function () {
            return new Thickness(1, this.w9, this.xb, this.xa, this.w8);
        },
        enumerable: false,
        configurable: true
    });
    FinalValueLayer.prototype.w4 = function () {
        return this.axisAnnotationFormatLabel != null;
    };
    FinalValueLayer.prototype.vs = function (a, b) {
        if (this.w3 == null || this.w3 == a) {
            if (!this.at.c) {
                this.pp(b);
            }
        }
    };
    FinalValueLayer.prototype.vu = function (a, b) {
        var e_1, _a;
        var _this = this;
        _super.prototype.vu.call(this, a, b);
        var c = a;
        c.f.clear();
        c.r.clear();
        c.q.clear();
        c.ac.clear();
        c.p.clear();
        c.ab.clear();
        c.h.clear();
        c.g.clear();
        c.i.clear();
        c.k.clear();
        c.m.clear();
        c.l.clear();
        c.j.clear();
        c.n.clear();
        c.o.clear();
        c.t.clear();
        c.s.clear();
        c.u.clear();
        c.w.clear();
        c.y.clear();
        c.x.clear();
        c.v.clear();
        c.z.clear();
        c.aa.clear();
        if (this.ul(this.w3)) {
            this.xs(this.w3, c);
        }
        else {
            try {
                for (var _b = __values(fromEnum(this.cy.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var d = _c.value;
                    if (this.ul(d)) {
                        this.xs(d, c);
                    }
                    if (d.isStacked) {
                        d.n5(function (e) {
                            if (_this.ul(e)) {
                                _this.xs(e, c);
                            }
                            if (e.dv) {
                                e.n3(function (f) {
                                    if (_this.ul(f)) {
                                        _this.xs(f, c);
                                    }
                                    return true;
                                });
                            }
                            return true;
                        });
                    }
                    if (d.dv) {
                        d.n3(function (e) {
                            if (_this.ul(e)) {
                                _this.xs(e, c);
                            }
                            return true;
                        });
                    }
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
        }
    };
    FinalValueLayer.prototype.ul = function (a) {
        if (!_super.prototype.ul.call(this, a)) {
            return false;
        }
        if (this.xp != null) {
            if (a.ep) {
                var b = a.lu();
                if (!Base.equalsStatic(this.xp, b)) {
                    return false;
                }
            }
            else {
                if (!Base.equalsStatic(this.xp, a.name)) {
                    return false;
                }
            }
        }
        return true;
    };
    FinalValueLayer.prototype.oo = function () {
        _super.prototype.oo.call(this);
        if (!this.at.c && !this.dj()) {
            return;
        }
        if (this.dj()) {
            this.xt(this.ug, false);
        }
        else {
            this.xt(this.ue, false);
        }
    };
    FinalValueLayer.prototype.ya = function (a) {
        var b = NaN;
        var c = NaN;
        var d = this.w2;
        if (d == 0) {
            d = 1;
        }
        var e = false;
        if (d == 2) {
            e = true;
        }
        if (a.isVertical) {
            var f = a.as();
            if (f != null) {
                if (d == 1 || d == 2) {
                    var g = this.to(this.cj);
                    if (f.ch) {
                        c = a.tm({ $type: Point_$type, x: g.right, y: g.bottom }).y;
                    }
                    else {
                        c = a.tm({ $type: Point_$type, x: g.right, y: g.top }).y;
                    }
                }
                else {
                    if (f.ch) {
                        c = 1;
                    }
                    else {
                        c = 0;
                    }
                }
            }
            return a.th({ $type: Point_$type, x: 0, y: c }, e, true);
        }
        else {
            var h = a.as();
            if (h != null) {
                if (d == 1 || d == 2) {
                    var i = this.to(this.cj);
                    if (h.ch) {
                        b = a.tm({ $type: Point_$type, x: i.left, y: i.top }).x;
                    }
                    else {
                        b = a.tm({ $type: Point_$type, x: i.right, y: i.top }).x;
                    }
                }
                else {
                    if (h.ch) {
                        b = 0;
                    }
                    else {
                        b = 1;
                    }
                }
            }
            if (a.ek) {
                return a.th({ $type: Point_$type, x: b, y: 0 }, e, true);
            }
            else {
                return a.th({ $type: Point_$type, x: b, y: 0 }, e, true);
            }
        }
    };
    FinalValueLayer.prototype.xs = function (a, b) {
        var c = this.ya(a);
        var d = this.tm(c);
        var e = this.ss;
        if (e == null) {
            e = this.sw;
        }
        if (e == null) {
            e = a.ss;
            if (e != null) {
                e = this.w1.b8(e);
            }
        }
        AxisAnnotationFrameManager.c(b, c, a, this.cy, this.getEffectiveViewport(), e, this.x7, this.w7, this.x9, this.x8, this.yb, this.xc, this.x7, this.w7, this.x9, this.x8, this.yb, this.xc, a.isVertical, !a.isVertical);
    };
    FinalValueLayer.prototype.xt = function (a, b) {
        var c = false;
        if (this.w5 == null) {
            c = true;
            this.w6 = new List$1(Axis.$, 0);
            this.w5 = new Dictionary$2(Axis.$, Pool$1.$.specialize(AxisAnnotation.$), 0);
        }
        AxisAnnotationFrameManager.d(this, a, c, this.w5, this.w6, b, this.xd, this.xd, this.axisAnnotationFormatLabel, this.axisAnnotationFormatLabel);
    };
    FinalValueLayer.prototype.vx = function (a, b) {
        _super.prototype.vx.call(this, a, b);
        if (this.dj()) {
            this.xt(this.ug, true);
        }
        else {
            this.xt(this.ue, false);
        }
    };
    FinalValueLayer.prototype.fm = function () {
        return true;
    };
    FinalValueLayer.prototype.o8 = function (a, b, c, d) {
        var e_2, _a;
        _super.prototype.o8.call(this, a, b, c, d);
        switch (b) {
            case FinalValueLayer.$$p[11]:
            case FinalValueLayer.$$p[12]:
                this.pp(true);
                break;
            case FinalValueLayer.$$p[1]:
            case FinalValueLayer.$$p[0]:
            case FinalValueLayer.$$p[3]:
            case FinalValueLayer.$$p[5]:
            case FinalValueLayer.$$p[7]:
            case FinalValueLayer.$$p[6]:
            case FinalValueLayer.$$p[4]:
            case FinalValueLayer.$$p[8]:
            case FinalValueLayer.$$p[9]:
            case FinalValueLayer.$$p[10]:
                this.pp(true);
                break;
            case "SeriesViewer":
                var e = this.w6;
                var f = this.w5;
                if (f != null) {
                    var _loop_1 = function (g) {
                        var h = g.value;
                        h.c(function (i) { return g.key.an.remove(i); });
                        h.clear();
                    };
                    try {
                        for (var _b = __values(fromEnum(f)), _c = _b.next(); !_c.done; _c = _b.next()) {
                            var g = _c.value;
                            _loop_1(g);
                        }
                    }
                    catch (e_2_1) {
                        e_2 = { error: e_2_1 };
                    }
                    finally {
                        try {
                            if (_c && !_c.done && (_a = _b.return))
                                _a.call(_b);
                        }
                        finally {
                            if (e_2)
                                throw e_2.error;
                        }
                    }
                    e.clear();
                    f.clear();
                }
                break;
        }
    };
    FinalValueLayer.$t = markType(FinalValueLayer, 'FinalValueLayer', AnnotationLayer.$);
    FinalValueLayer.$$p = markDep(DependencyProperty, PropertyMetadata, FinalValueLayer, 'raisePropertyChanged', ['AxisAnnotationBackgroundCornerRadius:w7:xu', [1, DeviceUtils.g(3)], 'AxisAnnotationBackground:x7:xv', [Brush.$, null], 'AxisAnnotationInterpolatedValuePrecision:xd:xw', [1, -1], 'AxisAnnotationOutline:x8:xx', [Brush.$, null], 'AxisAnnotationPaddingBottom:w8:xy', [1, NaN], 'AxisAnnotationPaddingLeft:w9:xz', [1, NaN], 'AxisAnnotationPaddingRight:xa:x0', [1, NaN], 'AxisAnnotationPaddingTop:xb:x1', [1, NaN], 'AxisAnnotationStrokeThickness:xc:x2', [1, NaN], 'AxisAnnotationTextColor:x9:x3', [Brush.$, null], 'FinalValueSelectionMode:w2:x4', [FinalValueSelectionMode_$type, enumGetBox(FinalValueSelectionMode_$type, 0)], 'TargetSeriesName:xp:x5', [2, null], 'TargetSeries:w3:x6', [Series.$, null]]);
    return FinalValueLayer;
}(AnnotationLayer));
export { FinalValueLayer };
/**
 * @hidden
 */
var FinalValueLayerView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinalValueLayerView, _super);
    function FinalValueLayerView(a) {
        var _this = _super.call(this, a) || this;
        _this.b7 = null;
        _this.b7 = a;
        return _this;
    }
    FinalValueLayerView.prototype.au = function () {
        _super.prototype.au.call(this);
    };
    FinalValueLayerView.prototype.b8 = function (a) {
        if (a == null) {
            return a;
        }
        return BrushUtil.m(a, 0.1);
    };
    FinalValueLayerView.prototype.an = function (a) {
        _super.prototype.an.call(this, a);
    };
    FinalValueLayerView.$t = markType(FinalValueLayerView, 'FinalValueLayerView', AnnotationLayerView.$);
    return FinalValueLayerView;
}(AnnotationLayerView));
export { FinalValueLayerView };
