import { __extends } from "tslib";
import { IgCollection } from "igniteui-angular-core";
import { markType } from "igniteui-angular-core";
import { SyncableObservableCollection$2 } from "igniteui-angular-core";
import { SeriesLayer as SeriesLayer_internal } from './SeriesLayer';
import { IgxSeriesLayer as IgxSeriesLayer } from './igx-series-layer';
var IgxSeriesLayerCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgxSeriesLayerCollection, _super);
    function IgxSeriesLayerCollection(list) {
        var _this = _super.call(this) || this;
        if (!IgxSeriesLayer.$type) {
            IgxSeriesLayer.$type = markType(IgxSeriesLayer, "IgxSeriesLayer");
        }
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgxSeriesLayerCollection.prototype._createInnerColl = function () {
        if (!IgxSeriesLayer.$type) {
            IgxSeriesLayer.$type = markType(IgxSeriesLayer, "IgxSeriesLayer");
        }
        var coll = new SyncableObservableCollection$2(IgxSeriesLayer.$type, SeriesLayer_internal.$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext._implementation;
        };
        coll.createFrom = function (int) {
            var ext = int.externalObject;
            if (!ext) {
                ext = new IgxSeriesLayer();
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    };
    return IgxSeriesLayerCollection;
}(IgCollection));
export { IgxSeriesLayerCollection };
