import { AnnotationLayer } from "./AnnotationLayer";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { DependencyProperty } from "igniteui-angular-core";
import { CategoryHighlightLayerFrame } from "./CategoryHighlightLayerFrame";
import { Type } from "igniteui-angular-core";
import { SeriesView } from "./SeriesView";
import { Axis } from "./Axis";
import { Frame } from "./Frame";
import { CategoryHighlightFrameRect } from "./CategoryHighlightFrameRect";
import { List$1 } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { Pool$1 } from "igniteui-angular-core";
import { Rectangle } from "igniteui-angular-core";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { Brush } from "igniteui-angular-core";
import { RenderingContext } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class CategoryHighlightLayer extends AnnotationLayer {
    static $t: Type;
    protected get_d5(): boolean;
    constructor();
    protected cg(): SeriesView;
    o0(a: SeriesView): void;
    protected w1: CategoryHighlightLayerView;
    w0: CategoryAxisBase;
    w3: boolean;
    get w4(): number;
    set w4(a: number);
    static readonly xb: DependencyProperty;
    protected vr(a: Axis, b: boolean): void;
    private w2;
    protected vu(a: Frame, b: SeriesView): void;
    private w9;
    w8(a: Rect, b: CategoryHighlightLayerFrame, c: Axis): void;
    protected vx(a: Frame, b: SeriesView): void;
    protected fm(): boolean;
    xa(a: CategoryHighlightFrameRect, b: Rectangle): void;
    protected o8(a: any, b: string, c: any, d: any): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class CategoryHighlightLayerView extends AnnotationLayerView {
    static $t: Type;
    constructor(a: CategoryHighlightLayer);
    protected b7: CategoryHighlightLayer;
    b8: Pool$1<Rectangle>;
    au(): void;
    protected b9: List$1<Rectangle>;
    private cg;
    private cb;
    private cd;
    private cc;
    ce(a: Brush): Brush;
    cf(a: Brush): Brush;
    ca(a: Rectangle, b: number, c: number, d: number, e: number): void;
    protected a8(a: RenderingContext, b: boolean): void;
    an(a: any): void;
}
