import { AnnotationLayer } from "./AnnotationLayer";
import { Series } from "./Series";
import { CategoryItemHighlightType } from "./CategoryItemHighlightType";
import { MarkerType } from "./MarkerType";
import { Brush } from "igniteui-angular-core";
import { DataTemplate } from "igniteui-angular-core";
import { CategoryItemHighlightLayerFrame } from "./CategoryItemHighlightLayerFrame";
import { Type, Point } from "igniteui-angular-core";
import { SeriesView } from "./SeriesView";
import { Frame } from "./Frame";
import { ItemHighlightFrameRect } from "./ItemHighlightFrameRect";
import { List$1 } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { Pool$1 } from "igniteui-angular-core";
import { Rectangle } from "igniteui-angular-core";
import { ContentControl } from "igniteui-angular-core";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { RenderingContext } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class CategoryItemHighlightLayer extends AnnotationLayer {
    static $t: Type;
    protected get_d5(): boolean;
    constructor();
    protected cg(): SeriesView;
    o0(a: SeriesView): void;
    protected w0: CategoryItemHighlightLayerView;
    w4: Series;
    xi: string;
    w8: boolean;
    w1: CategoryItemHighlightType;
    w3: MarkerType;
    x2: Brush;
    x3: Brush;
    xr: DataTemplate;
    xa: number;
    w7: boolean;
    protected vs(a: Series, b: boolean): void;
    protected ul(a: Series): boolean;
    protected vu(a: Frame, b: SeriesView): void;
    private w6;
    private w5;
    protected o8(a: any, b: string, c: any, d: any): void;
    private w9;
    private xo;
    xm(a: Point, b: CategoryItemHighlightLayerFrame, c: Series): void;
    private w2;
    xn(a: Rect, b: CategoryItemHighlightLayerFrame, c: Series): void;
    protected vx(a: Frame, b: SeriesView): void;
    xp(a: ItemHighlightFrameRect, b: ContentControl): void;
    xq(a: ItemHighlightFrameRect, b: Rectangle): void;
    protected fm(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class CategoryItemHighlightLayerView extends AnnotationLayerView {
    static $t: Type;
    constructor(a: CategoryItemHighlightLayer);
    protected b7: CategoryItemHighlightLayer;
    b9: Pool$1<Rectangle>;
    b8: Pool$1<ContentControl>;
    au(): void;
    protected ca: List$1<ContentControl>;
    protected cb: List$1<Rectangle>;
    private cn;
    private ch;
    private cj;
    private ci;
    private ck;
    private cc;
    private ce;
    private cd;
    cl(a: Brush): Brush;
    cm(a: Brush): Brush;
    cg(a: Rectangle, b: number, c: number, d: number, e: number): void;
    cf(a: ContentControl, b: number, c: number): void;
    protected bj(a: any, b: number): void;
    protected a8(a: RenderingContext, b: boolean): void;
    an(a: any): void;
}
