import { HorizontalAnchoredCategorySeries } from "./HorizontalAnchoredCategorySeries";
import { ConsolidatedItemsPosition } from "./ConsolidatedItemsPosition";
import { SeriesView } from "./SeriesView";
import { SeriesVisibleRangeMode } from "./SeriesVisibleRangeMode";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { Type, Point } from "igniteui-angular-core";
import { CategoryMode } from "./CategoryMode";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { Rect } from "igniteui-angular-core";
import { CategoryFrame } from "./CategoryFrame";
import { Pool$1 } from "igniteui-angular-core";
import { Rectangle } from "igniteui-angular-core";
import { CategorySeriesView } from "./CategorySeriesView";
import { List$1 } from "igniteui-angular-core";
import { AnchoredCategorySeriesView } from "./AnchoredCategorySeriesView";
import { RenderingContext } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class ColumnSeries extends HorizontalAnchoredCategorySeries {
    static $t: Type;
    protected get_ed(): boolean;
    protected get_ey(): boolean;
    protected ip(): number;
    protected cg(): SeriesView;
    ze: ColumnSeriesView;
    o0(a: SeriesView): void;
    cm(): SeriesVisibleRangeMode;
    protected vw(): CategoryTransitionInMode;
    constructor();
    zi: number;
    zj: number;
    protected get_du(): boolean;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    private zk;
    ts(a: Point): Rect;
    f4(a: Point, b: boolean): boolean;
    nj(a: boolean, b: SeriesView): void;
    h0(): number;
    w5(a: CategoryFrame, b: CategorySeriesView): void;
    private zf;
    get zg(): ConsolidatedItemsPosition;
    set zg(a: ConsolidatedItemsPosition);
    private zh;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class ColumnSeriesView extends AnchoredCategorySeriesView {
    static $t: Type;
    au(): void;
    protected dd: ColumnSeries;
    constructor(a: ColumnSeries);
    dl(): Rectangle;
    protected df: List$1<Rectangle>;
    dg(a: Rectangle): void;
    di(a: Rectangle): void;
    dh(a: Rectangle): void;
    dj(a: Rectangle, b: number, c: number): void;
    protected ac(a: number): any;
    private dk;
    protected ab(a: number): any;
    protected a8(a: RenderingContext, b: boolean): void;
    de: Pool$1<Rectangle>;
    an(a: any): void;
}
