import { FinancialOverlay } from "./FinancialOverlay";
import { List$1 } from "igniteui-angular-core";
import { Type, Point } from "igniteui-angular-core";
import { CategoryFrame } from "./CategoryFrame";
import { Rect } from "igniteui-angular-core";
import { SeriesView } from "./SeriesView";
import { FinancialSeriesView } from "./FinancialSeriesView";
import { FinancialBucketCalculator } from "./FinancialBucketCalculator";
import { Polyline } from "igniteui-angular-core";
import { Polygon } from "igniteui-angular-core";
import { RenderingContext } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class PriceChannelOverlay extends FinancialOverlay {
    static $t: Type;
    constructor();
    yb: number;
    protected o8(a: any, b: string, c: any, d: any): void;
    gl(a: Rect, b: Rect, c: SeriesView): boolean;
    protected x4(): boolean;
    xf(a: CategoryFrame, b: FinancialSeriesView): void;
    nj(a: boolean, b: SeriesView): void;
    xh(a: CategoryFrame, b: FinancialSeriesView): void;
    ya: List$1<number>;
    x9: List$1<number>;
    protected cg(): SeriesView;
    o0(a: SeriesView): void;
    private x8;
    h9(a: Point, b: boolean, c: boolean): number;
    jd(a: Point, b: boolean): number;
    jf(a: Point, b: boolean): number;
    h2(): number;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class PriceChannelBucketCalculator extends FinancialBucketCalculator {
    static $t: Type;
    constructor(a: FinancialSeriesView);
    protected f: PriceChannelOverlayView;
    getBucket(a: number): number[];
}
/**
 * @hidden
 */
export declare class PriceChannelOverlayView extends FinancialSeriesView {
    static $t: Type;
    private cb;
    private cg;
    private ch;
    get ca(): Polygon;
    get ce(): Polyline;
    get cf(): Polyline;
    b6: PriceChannelOverlay;
    constructor(a: PriceChannelOverlay);
    au(): void;
    protected b1(): FinancialBucketCalculator;
    b7(): void;
    b8(a: number, b: (arg1: number) => number, c: (arg1: number) => number, d: (arg1: number) => number, e: (arg1: number) => number): void;
    private b9;
    private cc;
    private cd;
    protected be(): void;
    protected a8(a: RenderingContext, b: boolean): void;
    an(a: any): void;
}
