import { HorizontalRangeCategorySeries } from "./HorizontalRangeCategorySeries";
import { SeriesView } from "./SeriesView";
import { Point, Type } from "igniteui-angular-core";
import { CategoryMode } from "./CategoryMode";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { CategoryFrame } from "./CategoryFrame";
import { CategorySeriesView } from "./CategorySeriesView";
import { List$1 } from "igniteui-angular-core";
import { Polyline } from "igniteui-angular-core";
import { Polygon } from "igniteui-angular-core";
import { RangeCategorySeriesView } from "./RangeCategorySeriesView";
import { RenderingContext } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class RangeAreaSeries extends HorizontalRangeCategorySeries {
    static $t: Type;
    protected cg(): SeriesView;
    o0(a: SeriesView): void;
    yk: RangeAreaSeriesView;
    protected get_d9(): boolean;
    protected get_d8(): boolean;
    protected yl(a: Point, b: Point, c: Point, d: boolean): boolean;
    f4(a: Point, b: boolean): boolean;
    constructor();
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    nj(a: boolean, b: SeriesView): void;
    w5(a: CategoryFrame, b: CategorySeriesView): void;
    get useHighMarkerFidelity(): boolean;
}
/**
 * @hidden
 */
export declare class RangeAreaSeriesView extends RangeCategorySeriesView {
    static $t: Type;
    protected c5: RangeAreaSeries;
    constructor(a: RangeAreaSeries);
    au(): void;
    private dd;
    private c9;
    private de;
    get df(): Polyline;
    get da(): Polygon;
    get dg(): Polyline;
    c6(): void;
    c7(a: number, b: List$1<number[]>, c: boolean): void;
    private dc;
    private db;
    private c8;
    protected be(): void;
    protected a8(a: RenderingContext, b: boolean): void;
    an(a: any): void;
}
