import { Series } from "./Series";
import { DependencyProperty } from "igniteui-angular-core";
import { DependencyObject } from "igniteui-angular-core";
import { HighlightingInfo } from "./HighlightingInfo";
import { ShapeItemSearchMode } from "./ShapeItemSearchMode";
import { IFastItemColumn$1 } from "igniteui-angular-core";
import { Point, Type } from "igniteui-angular-core";
import { NumericXAxis } from "./NumericXAxis";
import { NumericYAxis } from "./NumericYAxis";
import { List$1 } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { StyleShapeEventArgs } from "./StyleShapeEventArgs";
import { Axis } from "./Axis";
import { FrameworkElement } from "igniteui-angular-core";
import { DataContext } from "igniteui-angular-core";
import { Marker } from "./Marker";
import { Tuple$2 } from "igniteui-angular-core";
import { ShapeHitRegion } from "./ShapeHitRegion";
import { AssigningShapeStyleEventArgs } from "./AssigningShapeStyleEventArgs";
import { AssigningShapeMarkerStyleEventArgs } from "./AssigningShapeMarkerStyleEventArgs";
import { SeriesLayerPropertyOverlay } from "./SeriesLayerPropertyOverlay";
import { FlattenedShape } from "./FlattenedShape";
import { SeriesView } from "./SeriesView";
import { RenderSurface } from "./RenderSurface";
import { Dictionary$2 } from "igniteui-angular-core";
import { AssigningSeriesShapeStyleEventArgsBase } from "./AssigningSeriesShapeStyleEventArgsBase";
import { SeriesRenderManager } from "./SeriesRenderManager";
import { Shape } from "igniteui-angular-core";
import { AssigningSeriesStyleEventArgsBase } from "./AssigningSeriesStyleEventArgsBase";
import { FastItemsSourceEventAction } from "igniteui-angular-core";
import { AxisRange } from "./AxisRange";
import { Style } from "igniteui-angular-core";
import { StyleSelector } from "./StyleSelector";
import { Path } from "igniteui-angular-core";
import { Pool$1 } from "igniteui-angular-core";
import { PointCollection } from "igniteui-angular-core";
import { PathGeometry } from "igniteui-angular-core";
import { RenderingContext } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare abstract class ShapeSeriesBase extends Series {
    static $t: Type;
    constructor();
    ng(): void;
    ag(): Axis[];
    ju(a: any, b: string): any;
    u2: boolean;
    u1: boolean;
    protected uu: boolean;
    protected ut: boolean;
    protected get_es(): boolean;
    private uf;
    private ug;
    protected get_du(): boolean;
    protected ud(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected ue(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    private ul;
    get um(): ShapeItemSearchMode;
    set um(a: ShapeItemSearchMode);
    protected un(): ShapeItemSearchMode;
    uo: ShapeItemSearchMode;
    vk: number;
    vj: number;
    hv(a: Point): number;
    private t5;
    private t6;
    protected v2(a: Point): Tuple$2<number, Point>;
    private v1;
    protected get_uv(): boolean;
    protected get uv(): boolean;
    private v0;
    protected vf(a: Point): number;
    th(a: Point, b: boolean, c: boolean): Point;
    jr(a: Point): any;
    protected uc(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    ax(a: any, b: Point, c: boolean): HighlightingInfo;
    ay(a: any, b: Point, c: boolean): HighlightingInfo;
    assigningShapeStyle: (sender: any, args: AssigningShapeStyleEventArgs) => void;
    assigningShapeMarkerStyle: (sender: any, args: AssigningShapeMarkerStyleEventArgs) => void;
    protected u8(): boolean;
    protected u7(): boolean;
    protected up: ShapeSeriesRenderManager;
    vw: string;
    get vn(): string;
    set vn(a: string);
    static readonly wf: DependencyProperty;
    protected fn(): boolean;
    protected g0(): List$1<SeriesLayerPropertyOverlay>;
    private v4;
    private ur;
    get us(): IFastItemColumn$1<any>;
    set us(a: IFastItemColumn$1<any>);
    ui: NumericXAxis;
    uk: NumericYAxis;
    private uz;
    private static u3;
    private convertToListList;
    protected c5(a: string): IFastItemColumn$1<any>;
    protected o8(a: any, b: string, c: any, d: any): void;
    protected u6(): boolean;
    protected u5(): boolean;
    ux(a: any): boolean;
    uw(a: any): boolean;
    private uh;
    private uj;
    private ve;
    va: List$1<Rect>;
    private wc;
    private wq;
    private vc;
    private t2;
    private t4;
    private t3;
    private t1;
    protected get_u0(): boolean;
    protected get u0(): boolean;
    protected u9(): boolean;
    pq(a: boolean): void;
    po(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    protected wb(a: SeriesView): void;
    protected v7(a: FrameworkElement, b: boolean, c: number, d: number, e: boolean, f: boolean): void;
    protected v6(a: number, b: number, c: boolean): void;
    protected v9(a: AssigningShapeStyleEventArgs): void;
    protected v8(a: AssigningShapeMarkerStyleEventArgs): void;
    t7(a: number, b: number): any[];
    protected t8(a: number, b: number): any[];
    private static wa;
    ob(): void;
    protected qn(a: Rect, b: Rect): void;
    protected qm(a: Rect, b: Rect): void;
    protected no(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    gl(a: Rect, b: Rect, c: SeriesView): boolean;
    protected get_u4(): boolean;
    protected get u4(): boolean;
    o0(a: SeriesView): void;
    private uq;
    private vd;
    private ub;
    private v3;
    wp: Rect;
    private we;
    nj(a: boolean, b: SeriesView): void;
    private v5;
    private wd;
    au(a: Point, b: boolean): DataContext;
    vl(a: number): any;
    protected get_gf(): boolean;
    protected set_gf(a: boolean): void;
    vg: number;
    vh: number;
    aq(a: Axis): AxisRange;
    protected get_fa(): boolean;
    protected get_ey(): boolean;
    get uy(): boolean;
    wr(a: any, b: DependencyObject, c: Style): Style;
    styleShape: (sender: any, e: StyleShapeEventArgs) => void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class ShapeSeriesRenderManager extends SeriesRenderManager {
    static $t: Type;
    protected c(): AssigningSeriesStyleEventArgsBase;
    protected a(): AssigningSeriesShapeStyleEventArgsBase;
    aw: AssigningShapeMarkerStyleEventArgs;
    ax: AssigningShapeStyleEventArgs;
    a1(a: Shape, b: number, c: boolean): void;
    ay(a: ShapeSeriesBase, b: boolean, c: (orderedStartIndex: number, orderedEndIndex: number) => any[]): void;
    az(a: Series, b: boolean, c: (orderedStartIndex: number, orderedEndIndex: number) => any[]): void;
    a0(a: AssigningSeriesStyleEventArgsBase, b: number, c: number, d: boolean): void;
}
/**
 * @hidden
 */
export declare abstract class ShapeSeriesViewBase extends SeriesView {
    static $t: Type;
    constructor(a: ShapeSeriesBase);
    cc: Dictionary$2<number, FlattenedShape>;
    b4(a: Point): Marker;
    get ce(): List$1<ShapeHitRegion>;
    protected b8(): Pool$1<FrameworkElement>;
    cb(a: Rect): boolean;
    static cf(a: List$1<FlattenedShape>): List$1<PointCollection>;
    get ca(): boolean;
    protected b6: ShapeSeriesBase;
    private cd;
    ci(a: number, b: any, c: Rect, d: List$1<FlattenedShape>): void;
    protected c4(a: number, b: any): FrameworkElement;
    protected abstract ck(a: FrameworkElement, b: PathGeometry): void;
    static cl(a: ShapeSeriesViewBase, b: Path, c: any): void;
    cp(a: (arg1: FrameworkElement) => void): void;
    cm(a: FrameworkElement, b: any, c: boolean): void;
    protected co(a: FrameworkElement, b: boolean): void;
    private cj;
    private cx;
    protected abstract c5(a: number, b: List$1<PointCollection>): PathGeometry;
    cu(): void;
    ct(): void;
    private ch;
    cw(a: number, b: number): void;
    cn(): void;
    protected cg: List$1<Path>;
    c1(): FrameworkElement;
    cq(a: FrameworkElement): void;
    cr(a: FrameworkElement): void;
    cs(a: FrameworkElement): void;
    protected b9: Pool$1<FrameworkElement>;
    c6(a: number, b: List$1<PointCollection>, c: boolean): PathGeometry;
    protected ac(a: number): any;
    private c7;
    protected ab(a: number): any;
    protected a8(a: RenderingContext, b: boolean): void;
    private b7;
    private c8;
    get c9(): Style;
    cz(a: StyleSelector): void;
    cy(a: Style): void;
    c2(a: Point, b: boolean): FrameworkElement;
    c3(a: Point, b: boolean, c: boolean): FrameworkElement;
    b5(a: Point, b: boolean, c: boolean): ShapeHitRegion;
    private b1;
    private b3;
    private b2;
    private b0;
    cv(a: number[], b: number[], c: number[], d: number[]): void;
    c0(): void;
    an(a: any): void;
}
