import { HorizontalAnchoredCategorySeries } from "./HorizontalAnchoredCategorySeries";
import { SplineType } from "./SplineType";
import { SeriesView } from "./SeriesView";
import { AxisRange } from "./AxisRange";
import { Axis } from "./Axis";
import { Point, IList$1, Type } from "igniteui-angular-core";
import { CategorySeriesView } from "./CategorySeriesView";
import { List$1 } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { CollisionAvoider } from "./CollisionAvoider";
import { AnchoredCategorySeriesView } from "./AnchoredCategorySeriesView";
import { CategoryFrame } from "./CategoryFrame";
import { NumericAxisBase } from "./NumericAxisBase";
import { FastItemsSourceEventAction } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare abstract class SplineSeriesBase extends HorizontalAnchoredCategorySeries {
    static $t: Type;
    protected ip(): number;
    protected cg(): SeriesView;
    o0(a: SeriesView): void;
    p0(a: boolean): void;
    zh: SplineSeriesBaseView;
    zj: boolean;
    aq(a: Axis): AxisRange;
    protected get_d9(): boolean;
    ze(a: CategorySeriesView): number[][];
    zf(a: CategorySeriesView): number[][];
    protected zg: number[];
    zu(a: CategoryFrame, b: Rect, c: Rect, d: CategoryAxisBase, e: NumericAxisBase, f: CategorySeriesView): void;
    zk(a: CategoryFrame, b: number[], c: CollisionAvoider, d: number, e: number, f: CategorySeriesView, g: number): boolean;
    aj(a: CategoryAxisBase, b: List$1<number[]>, c: number, d: number, e: Point, f: boolean): number[][];
    w2(a: CategoryFrame, b: CategorySeriesView): void;
    zt(a: CategorySeriesView): void;
    private zn;
    hz(a: number, b: IList$1<number>, c: number, d: number, e: number, f: number, g: number, h: boolean): number;
    zo(a: CategoryAxisBase, b: Rect, c: Rect, d: Rect): number;
    private zm;
    protected get zq(): number;
    protected set zq(a: number);
    private zl;
    protected get zp(): number;
    protected set zp(a: number);
    zi: SplineType;
    protected zv(): void;
    protected o8(a: any, b: string, c: any, d: any): void;
    protected no(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class SplineSeriesBaseView extends AnchoredCategorySeriesView {
    static $t: Type;
    protected dd: SplineSeriesBase;
    constructor(a: SplineSeriesBase);
    de(): number;
    protected af(): void;
}
